/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.gtm.datvew.aktionen;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.gtm.datvew.Activator;
import de.inovat.buv.gtm.datvew.lib.BaumHilfsFunktionen;
import de.inovat.buv.projektlib.rechtevew.aktionen.AktionenVew;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

//~ KLASSEN ===================================================================

/**
 * Die Klasse registriert die GTM-Aktionen.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public class AktionenGTM extends AbstractHandler {
    public static final String  ACTIVATOR_ID                    = Activator.PLUGIN_ID;
    public static final String  COMMAND_ID_FILTER               = ACTIVATOR_ID + ".filter";
    public static final String  COMMAND_ID_PERSPEKTIVE          = ACTIVATOR_ID + ".perspektive";
    public static final String  COMMAND_ID_SORTIRUNG            = ACTIVATOR_ID + ".sortierung";
    public static final String  COMMAND_ID_SPALTENAUSWAHL       = ACTIVATOR_ID + ".spaltenauswahl";
    public static final String  COMMAND_ID_TABELLENDARSTELLUNG  = ACTIVATOR_ID + ".tabellendarstellung";
    public static final String  COMMAND_ID_TABELLENVERWALTUNG   = ACTIVATOR_ID + ".tabellenverwaltung";
    public static final String  FUNKTION_ID_FILTER              = ACTIVATOR_ID + ".funktionen.filter";
    public static final String  FUNKTION_ID_SORTIRUNG           = ACTIVATOR_ID + ".funktionen.sortierung";
    public static final String  FUNKTION_ID_SPALTENAUSWAHL      = ACTIVATOR_ID + ".funktionen.spaltenauswahl";
    public static final String  FUNKTION_ID_TABELLENDARSTELLUNG = ACTIVATOR_ID + ".funktionen.tabellendarstellung";
    public static final String  FUNKTION_ID_TABELLENVERWALTUNG  = ACTIVATOR_ID + ".funktionen.tabellenverwaltung";
    private static final String PERSPECTIVE_ID_INOVAT_GTM       = "de.inovat.buv.gtm.rw.Perspective";
    private static final String SICHT_ID_FILER                  = "de.inovat.buv.plugin.gtm.navigation.filter.view";
    private static final String SICHT_ID_SORTIRUNG              = "de.inovat.buv.plugin.gtm.navigation.sortierung.view";
    private static final String SICHT_ID_SPALTENAUSWAHL         = "de.inovat.buv.plugin.gtm.navigation.spalten.view";
    private static final String SICHT_ID_TABELLENVERWALTUNG     = "de.inovat.buv.plugin.gtm.navigation.tabellenverwaltung.view";

    //~ METHODEN ==============================================================

    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        String commandId = event.getCommand().getId();

        // Perspektive:
        if (commandId.equals(COMMAND_ID_PERSPEKTIVE)) {
            AktionenVew.getInstanz().perspektiveOeffnen(PERSPECTIVE_ID_INOVAT_GTM, true);
        }

        // Tabellendarstellung:
        else if (commandId.equals(COMMAND_ID_TABELLENDARSTELLUNG)) {
            BaumHilfsFunktionen.oeffneTabellendarstellung();
        }

        // Verwaltungssichte:
        else if (commandId.equals(COMMAND_ID_TABELLENVERWALTUNG)) {
            AktionenVew.getInstanz().zeigeSicht(SICHT_ID_TABELLENVERWALTUNG);
        } else if (commandId.equals(COMMAND_ID_FILTER)) {
            AktionenVew.getInstanz().zeigeSicht(SICHT_ID_FILER);
        } else if (commandId.equals(COMMAND_ID_SORTIRUNG)) {
            AktionenVew.getInstanz().zeigeSicht(SICHT_ID_SORTIRUNG);
        } else if (commandId.equals(COMMAND_ID_SPALTENAUSWAHL)) {
            AktionenVew.getInstanz().zeigeSicht(SICHT_ID_SPALTENAUSWAHL);
        }

        return null;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 21.10.13
