/*
 * Copyright (c) 2014 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kniss
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Contact Information:
 * inovat, Dipl.-Ing. H. C. Kniss
 * An der Krautwiese 37
 * D-53783 Eitorf
 * +49 (0)2243 8464 193
 * info@inovat.de
 * www.inovat.de
 */



package de.inovat.buv.gtm.datvew.lib;

//~ NICHT JDK IMPORTE =========================================================

import de.bsvrz.dav.daf.main.config.SystemObject;

import org.eclipse.core.runtime.IAdapterFactory;

//~ KLASSEN ===================================================================

/**
 * {@link IAdapterFactory} fr inovatGTM-Objekte von Typ {@link ISystemObjekt}.
 * </p>
 * Auf das im Navigationsbaum selektierte Objekt kann wie folgt zugegriefen werden:
 * </p>
 * <code>
 * ISelection sel = getSite().getWorkbenchWindow().getSelectionService().getSelection();</br>
 * if (sel instanceof StructuredSelection) {</br>
 *      StructuredSelection strSel = (StructuredSelection) sel;</br>
 *      Object        so      = Platform.getAdapterManager().getAdapter(strSel.getFirstElement(), SystemObject.class);</br>
 *      if (so != null) {</br>
 *              ...</br>
 *      }</br>
 * }</br>
 * </code>
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public class GTMAdapterFactory implements IAdapterFactory {
    @Override
    public Object getAdapter(Object adaptableObject, Class adapterType) {
        Object adapter = null;

        if (adaptableObject instanceof ISystemObjekt) {
            if (adapterType == SystemObject.class) {
                adapter = ((ISystemObjekt) adaptableObject).getSystemObjekt();
            }
        }

        return adapter;
    }

    @Override
    public Class[] getAdapterList() {
        return new Class[] { SystemObject.class };
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 06.10.14
