/*
 * @(#)ImportPruefGUIVew.java   15.10.12
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.bast.importpruef;

//~ NICHT JDK IMPORTE =========================================================

import de.bsvrz.dav.daf.main.archive.ArchiveData;
import de.bsvrz.dav.daf.main.archive.ArchiveDataKind;
import de.bsvrz.dav.daf.main.archive.ArchiveDataKindCombination;
import de.bsvrz.dav.daf.main.archive.ArchiveDataQueryResult;
import de.bsvrz.dav.daf.main.archive.ArchiveDataSpecification;
import de.bsvrz.dav.daf.main.archive.ArchiveDataStream;
import de.bsvrz.dav.daf.main.archive.ArchiveOrder;
import de.bsvrz.dav.daf.main.archive.ArchiveQueryPriority;
import de.bsvrz.dav.daf.main.archive.ArchiveRequestOption;
import de.bsvrz.dav.daf.main.archive.ArchiveTimeSpecification;
import de.bsvrz.dav.daf.main.archive.TimingType;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.DataState;

import de.inovat.buv.gtm.datvew.lib.Fahrbahnen;
import de.inovat.buv.gtm.datvew.lib.SelektionVew;
import de.inovat.buv.gtm.datvew.lib.ZaehlStelle;
import de.inovat.buv.inovat.lib.debug.Log;
import de.inovat.buv.inovat.lib.funktionen.datum.DatumFunktionen;
import de.inovat.buv.plugin.gtm.bast.Activator;
import de.inovat.buv.plugin.gtm.bast.KonstantenGTMBast;
import de.inovat.buv.plugin.gtm.navigation.lib.LangzeitzaehlstellenAuswahlFunktionen;
import de.inovat.buv.projektlib.dav.DavArchivVew;
import de.inovat.buv.projektlib.dav.DavDatenVew;
import de.inovat.buv.projektlib.speicher.OrdnerEinstellungen;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.dialogs.ProgressMonitorDialog;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ITableColorProvider;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;

import static de.inovat.buv.inovat.lib.konstanten.Konstanten.NEWLINE;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_GELB;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_GRUEN_PALE;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_ORANGE;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_ROT_HELL;

//~ JDK IMPORTE ===============================================================

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import java.lang.reflect.InvocationTargetException;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

//~ KLASSEN ===================================================================

/**
 * Klasse verwaltet das GUI "BASt-Band-Import Prfung".
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 211 $ / $Date: 2012-10-09 11:50:12 +0200 (Di, 09. Okt 2012) $ / ($Author: LG $)
 */
public class ImportPruefGUIVew {
    private static final String[] AR_SPALTEN_NAMEN_FEST           = { "Prfung", "DZ", "FS" };
    private static final String   ASPEKT                          = "asp.messWertErsetzung";
    private static final String   ATG_2004                        = "atg.verkehrsDatenLangZeitIntervall";
    private static final String   ATG_2007                        = "atg.verkehrsDatenLangZeitIntervallGeschwindigkeitVerteilungFs";
    private static final String   ERGEBNIS_SCHNELLE_PRUEFUNG      = "Ergebnis der schnellen Prfung:";
    private static final String   ERGEBNIS_VOLLSTAENDIGE_PRUEFUNG = "Ergebnis der vollstndigen Prfung:";
    private static final String   TRENNZEICHEN                    = ";";
    private static final String   TYP                             = "typ.fahrStreifen";
    private static final String   VOLLSTAENDIG_GEPRUEFT           = "vollstndig geprft";

    //~ FELDER ================================================================

    /** Die Liste enthlt Zeilen aus der Tabelle, die ausgewhlt sind. */
    private ArrayList<Integer> _listeAusgewaehlterZeilen = new ArrayList<Integer>();

    /** Gefilterter Inhalt der Tabelle. */
    private List<BastDatenObjekt> _listeBastDatenObjekteGefiltert = new ArrayList<BastDatenObjekt>();

    /**
     * Liste aller Monaten aus dem Zeitbereich.
     * Jeder Monat wird als 1.Tag des Monats mit der Zeit 00:00:00 in Millis gespeichert.
     */
    private List<Long> _listeMonate = new ArrayList<Long>();

    /** Die selektierten Langzeitzaehlstellen. */
    private List<ZaehlStelle> _listeLzz = new ArrayList<ZaehlStelle>();

    /** Nicht gefilterter Inhalt der Tabelle. */
    private List<BastDatenObjekt> _listeBastDatenObjekte = new ArrayList<BastDatenObjekt>();

    /** Stellt fest, ob die Tabelle gefiltert wurde. */
    private boolean            _istFilter = false;
    private DataDescription    _dataDescription2004;
    private DataDescription    _dataDescription2007;
    private ClientDavInterface _dav;
    private DataModel          _davKonf;
    private ImportPruefGUI     _gui;
    private String             _tabelleBastFormat;
    private String             _tabelleBis;
    private List<ZaehlStelle>  _tabelleListeLzz;
    private String             _tabelleVon;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Erzeugt eine Instanz der Klasse ImportPruefGUIVew.
     *
     * @param gui GUI-Instanz.
     */
    public ImportPruefGUIVew(ImportPruefGUI gui) {

        // -------------------------------------------------------------------
        _gui = gui;

        // -------------------------------------------------------------------
        _davKonf = DavDatenVew.getInstanz().getDav().getDataModel();
        _dav     = DavDatenVew.getInstanz().getDav();

        // -------------------------------------------------------------------
        // Initialisiere Dav-Daten:
        Aspect         asp     = _davKonf.getAspect(ASPEKT);
        AttributeGroup atg2004 = _davKonf.getAttributeGroup(ATG_2004);
        AttributeGroup atg2007 = _davKonf.getAttributeGroup(ATG_2007);

        _dataDescription2004 = new DataDescription(atg2004, asp);
        _dataDescription2007 = new DataDescription(atg2007, asp);
    }

    //~ AUFZAEHLUNGSTYPEN =====================================================

    /**
     * Status der Archiv-Anfrage.
     */
    private enum Status {
        FEHLER("F", FARBE_ROT_HELL, "alle Datenzstze fehlen"),                          //
        OK("ok", FARBE_GRUEN_PALE, "alle Datenzstze liegen vor"),                       //
        UNTER_50("<50%", FARBE_ORANGE, "es liegen weniger als 50% der Datenstze vor"),  //
        UEBER_50(">50%", FARBE_GELB, "es liegen mehr als 50% der Datenstze vor");

        Color  _farbe;
        String _info;
        String _status;

        //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==========

        private Status(String status, Color farbe, String info) {
            _status = status;
            _farbe  = farbe;
            _info   = info;
        }

        //~ METHODEN ==========================================================

        /**
         * Ermittle Info fr angegebenen Status.
         *
         * @param status Status.
         *
         * @return Info fr angegebenen Status oder leeres String.
         */
        private static String ermittleInfo(String status) {
            for (Status st : Status.values()) {
                if (st._status.equals(status)) {
                    return st._info;
                }
            }

            return "";
        }
    }

    //~ METHODEN ==============================================================

    /**
     * Archivanfrage fr alle BastDatenObjekte.
     */
    private void archivAnfrageBastDaten() {

        // -----------------------------------------------------------------------
        final DataDescription dd;

        if (_gui.getRbtnBast2004().getSelection()) {
            dd = _dataDescription2004;
        } else {
            dd = _dataDescription2007;
        }

        // --------------------------------------------------------------------------------
        // Erstelle den WartenDialog:
        final ProgressMonitorDialog dialog = new ProgressMonitorDialog(Display.getDefault().getActiveShell()) {
            @Override
            protected void createCancelButton(Composite parent) {
                super.createCancelButton(parent);
                getButton(CANCEL).setText("Abbrechen");
                getButton(CANCEL).setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
            }
        };

        // --------------------------------------------------------------------------------
        // ffne den WartenDialog:
        final int anzZeilen = _listeBastDatenObjekte.size();
        final int anzMonate = anzZeilen * _listeMonate.size();

        try {
            dialog.run(true, true, new IRunnableWithProgress() {
                @Override
                public void run(IProgressMonitor monitor) throws InvocationTargetException, InterruptedException {
                    monitor.beginTask("Archivanfrage luft ...", anzMonate);

                    //
                    boolean istAbgebrochen = false;

                    // --------------------------------------------------------------------------------
                    // Archivanfrage fr alle BastDatenObjekt und alle Monate
                    // -------------------------------
                    // Betrachte alle BastDatenObjekt:
                    int zeile = -1;

                    for (BastDatenObjekt dat : _listeBastDatenObjekte) {

                        //
                        zeile++;

                        // Kein Archiv:
                        if (!_dav.getArchive().isArchiveAvailable()) {
                            String meldung = String.format("Das Archiv ist zur Zeit nicht verfgbar! Es wurden %d von %d Zeilen bearbeitet.", zeile, anzZeilen);

                            monitor.subTask(meldung);
                            Thread.sleep(3000);
                            Log.zeige(Log.erzeugeMeldung(Log.WARNUNG, Activator.PLUGIN_ID, meldung));

                            break;
                        }

                        // Abbruch:
                        if (istAbgebrochen) {
                            break;
                        }

                        // -------------------------------
                        // Betrachte alle Monate:
                        long   tagStunde;
                        Status status;

                        for (int i = 0; i < _listeMonate.size(); i++) {

                            //
                            monitor.worked(1);
                            monitor.subTask(String.format("%s -- %s -- %s", dat._zs.getSystemObjekt().getNameOrPidOrId(),  //
                                                          dat._fs.getSystemObjekt().getNameOrPidOrId(),                    //
                                                          formatiereDatum(_listeMonate.get(i))));

                            // Abbruch wird gedruckt:
                            if (monitor.isCanceled()) {
                                istAbgebrochen = true;

                                break;
                            }

                            // ----------------------
                            // Vereinfachte Variante der Prfung
                            // ----------------------
                            // 1.Tag 00:00
                            tagStunde = _listeMonate.get(i);
                            status    = archivAnfrageBastDaten(dat._fs.getSystemObjekt(), dd, tagStunde);

                            if (status == Status.OK) {

                                // ----------------------
                                // 15.Tag 12:00
                                tagStunde = DatumFunktionen.getVerschobenenDateTime(tagStunde, 0, 14);
                                tagStunde = DatumFunktionen.setzeZeit(tagStunde, 12, 0);
                                status    = archivAnfrageBastDaten(dat._fs.getSystemObjekt(), dd, tagStunde);

                                if (status == Status.OK) {

                                    // ----------------------
                                    // Letzter Tag 23:00
                                    tagStunde = DatumFunktionen.getMonatEnde(tagStunde);
                                    tagStunde = DatumFunktionen.setzeZeit(tagStunde, 23, 0);
                                    status    = archivAnfrageBastDaten(dat._fs.getSystemObjekt(), dd, tagStunde);

                                    // ----------------------
                                    if (status == Status.OK) {
                                        dat._arMonatenStatus[i] = Status.OK;
                                    } else {
                                        dat._arMonatenStatus[i] = Status.UEBER_50;
                                    }
                                } else {
                                    dat._arMonatenStatus[i] = Status.UNTER_50;
                                }
                            } else {
                                dat._arMonatenStatus[i] = Status.FEHLER;
                            }
                        }
                    }

                    // --------------------------------------------------------------------------------
                    // Abbruch:
                    if (istAbgebrochen) {
                        String meldung = String.format("Die Archivanfrage wurde abgebrochen! Es wurden %d von %d Zeilen bearbeitet.", zeile, anzZeilen);

                        monitor.subTask(meldung);
                        Thread.sleep(3000);
                        Log.zeige(Log.erzeugeMeldung(Log.WARNUNG, Activator.PLUGIN_ID, meldung));
                    }

                    // --------------------------------------------------------------------------------
                    // Schliesse den WartenDialog
                    monitor.done();
                }
            });
        }
        catch (Exception e) {
            Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Fehler bei der Archivanfrage", e));
        }
    }

    /**
     * Archivanfrage fr angegebene SystemObject,DataDescription und Zeitpunkt.
     *
     * @param so SystemObject.
     * @param dd DataDescription.
     * @param zeitPunkt Zeitpunkt.
     * @return Status.OK, falls Archivanfrage passende Daten liefert,
     * Status.FEHLER - sonst.
     */
    private Status archivAnfrageBastDaten(SystemObject so, DataDescription dd, long zeitPunkt) {
        Status status = Status.FEHLER;

        // -----------------------------------------------------------------------
        ArchiveTimeSpecification   archiveTimeSpecification   = new ArchiveTimeSpecification(TimingType.DATA_TIME, false, zeitPunkt, zeitPunkt);
        ArchiveDataKindCombination archiveDataKindCombination = new ArchiveDataKindCombination(ArchiveDataKind.ONLINE);
        ArchiveDataSpecification   archiveDataSpecification   = new ArchiveDataSpecification(  //
            archiveTimeSpecification, archiveDataKindCombination, ArchiveOrder.BY_INDEX,       //
            ArchiveRequestOption.NORMAL, dd, so);

        // -----------------------------------------------------------------------
        try {
            ArchiveDataQueryResult queryResult = _dav.getArchive().request(ArchiveQueryPriority.MEDIUM, archiveDataSpecification);

            if (queryResult.isRequestSuccessful()) {
                ArchiveDataStream[] archiveDataStream = queryResult.getStreams();

                for (ArchiveDataStream data : archiveDataStream) {
                    ArchiveData archivDaten = data.take();

                    while ((archivDaten != null)) {
                        if (archivDaten.getData() != null) {

                            // Als Ergebnis nur den letzten Datensatz betrachten:
                            if (archivDaten.getDataType().equals(DataState.DATA)) {

                                // Folgende einzelabfragen basieren auf einem Archivzustand (bug), das auch Daten zurck liefert,
                                // die nicht innerhalb des angefraten Archivzeitraumes liegen.
                                if (zeitPunkt == archivDaten.getDataTime()) {
                                    status = Status.OK;
                                }
                            } else {
                                status = Status.FEHLER;
                            }
                        }

                        archivDaten = data.take();
                    }
                }
            }
        }
        catch (Exception e) {
            Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Es sind Probleme bei der Archivanfrage aufgetreten", e));
        }

        return status;
    }

    /**
     * Button 'Export' wird selektiert.
     */
    protected void btnExportSelektiert() {

        // Exportiere die Tabelle in die csv-Datei:
        // ------------------------------------------------------------------
        // File-Dialog:
        FileDialog fileDialog = new FileDialog(_gui.getShell(), SWT.SAVE);

        fileDialog.setFilterExtensions(new String[] { "*.csv" });
        fileDialog.setText("Exportieren des Tabelleninhaltes in CSV Format.");
        fileDialog.setFilterPath(OrdnerEinstellungen.ermittleProjektAusgabenUnterOrdner(KonstantenGTMBast.ORDNER_BAST_IMPORT_PRUEF_CSV));

        // DateiName:
        String lzz;

        if (_tabelleListeLzz.size() == 1) {
            lzz = _tabelleListeLzz.get(0).getId();
        } else if (_tabelleListeLzz.size() > 1) {
            lzz = String.format("LZZ_%d_%s..", _tabelleListeLzz.size(), _tabelleListeLzz.get(0).getId());
        } else {
            lzz = "";
        }

        String dateiName = String.format("BAStImport_%s_von_%s_bis_%s_%s.csv", _tabelleBastFormat, _tabelleVon, _tabelleBis, lzz);

        fileDialog.setFileName(dateiName);

        // ffne den Dialog:
        String datei = fileDialog.open();

        if (datei != null) {

            // ------------------------------------------------------------------
            // Prfe, ob die Datei existiert:
            File file = new File(datei);

            if (file.exists()) {
                if (!MessageDialog.openQuestion(_gui.getShell(), "Frage", String.format(  //
                    "Datei <%s> existiert schon.\n\n Soll die berschrieben werden?", datei))) {
                    return;
                }
            }

            // ------------------------------------------------------------------
            // Erstelle csv-Datei:
            FileWriter out   = null;
            boolean    istOK = false;

            try {
                out = new FileWriter(datei);

                // ------------------------------------------------------------------
                // Titel:
                exportAusgabe(out, new String[] { DatumFunktionen.getDatumZeitAlsString(System.currentTimeMillis()), "BASt-Band-Import Prfung" });
                out.write(NEWLINE);
                exportAusgabe(out, new String[] { "Zeitbereichsangabe:", String.format("von %s bis %s", _tabelleVon, _tabelleBis) });
                exportAusgabe(out, new String[] { "BASt-Band Import Format:", _tabelleBastFormat });
                out.write(NEWLINE);
                exportAusgabe(out, new String[] { "Typ:", TYP });

                if (_tabelleBastFormat.equals("2004")) {
                    exportAusgabe(out, new String[] { "Attributgruppe:", ATG_2004 });
                } else {
                    exportAusgabe(out, new String[] { "Attributgruppe:", ATG_2007 });
                }

                exportAusgabe(out, new String[] { "Aspekt:", ASPEKT });
                out.write(NEWLINE);

                if (_tabelleListeLzz.size() > 0) {
                    exportAusgabe(out, new String[] { "Langzeitzhlstellenauswahl:", _tabelleListeLzz.get(0).getId() });

                    for (int i = 1; i < _tabelleListeLzz.size(); i++) {
                        exportAusgabe(out, new String[] { "", _tabelleListeLzz.get(i).getId() });
                    }
                }

                out.write(NEWLINE);

                // ------------------------------------------------------------------
                // Tabelle:
                // Legende:
                exportAusgabe(out, new String[] { "Legende:" });
                exportAusgabe(out, new String[] { ERGEBNIS_SCHNELLE_PRUEFUNG });

                for (Status st : Status.values()) {
                    exportAusgabe(out, new String[] { String.format("%s ---> %s", st._status, Status.ermittleInfo(st._status)) });
                }

                exportAusgabe(out, new String[] { ERGEBNIS_VOLLSTAENDIGE_PRUEFUNG });
                exportAusgabe(out, new String[] { String.format("%s.", ermittleInfo("xxx ok - yyy F")) });
                out.write(NEWLINE);

                // Spalten-berschriften:
                String[] arSpalten = new String[AR_SPALTEN_NAMEN_FEST.length + _listeMonate.size()];

                // Feste Spalten:
                for (int i = 0; i < AR_SPALTEN_NAMEN_FEST.length; i++) {
                    arSpalten[i] = AR_SPALTEN_NAMEN_FEST[i];
                }

                // Spalten mit Monat-Angaben:
                int iMonat = AR_SPALTEN_NAMEN_FEST.length;

                for (long monat : _listeMonate) {
                    arSpalten[iMonat] = formatiereDatum(monat);
                    iMonat++;
                }

                exportAusgabe(out, arSpalten);

                // Tabelleninhalt:
                List<BastDatenObjekt> liste;

                if (_istFilter) {
                    liste = _listeBastDatenObjekteGefiltert;
                } else {
                    liste = _listeBastDatenObjekte;
                }

                List<String> listeZeile;

                for (BastDatenObjekt dat : liste) {
                    listeZeile = new ArrayList<String>();

                    // Feste Spalten:
                    listeZeile.add(dat._vollPruefung ? VOLLSTAENDIG_GEPRUEFT : "");
                    listeZeile.add(dat._zs.getSystemObjekt().getNameOrPidOrId());
                    listeZeile.add(dat._fs.getSystemObjekt().getNameOrPidOrId());

                    // Spalten mit Monat-Angaben:
                    for (int i = 0; i < _listeMonate.size(); i++) {
                        listeZeile.add(formatiereStatusAnzeige(dat, i));
                    }

                    //
                    exportAusgabe(out, listeZeile.toArray(new String[listeZeile.size()]));
                }

                // ------------------------------------------------------------------
                out.close();
                istOK = true;
            }
            catch (Exception e) {
                Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Fehler bei der Erstellung der csv-Datei", e));

                //
                try {
                    if (out != null) {
                        out.close();
                    }
                }
                catch (IOException ignored) {}
            }

            // ------------------------------------------------------------------
            // Meldung:
            if (istOK) {
                MessageDialog.openInformation(_gui.getShell(), "Information", String.format  //
                    ("Die Datei\n\n<%s>\n\nwurde erfolgreich erstellt!", datei));
            } else {
                MessageDialog.openError(_gui.getShell(), "Fehler", String.format             //
                    ("Es ist ein Fehler bei der Erstellung der Datei\n\n<%s>\n\naufgetreten (siehe Meldungen im ErrorLog)!", datei));
            }
        }
    }

    /**
     * Button 'Filter Alle' wird selektiert.
     */
    protected void btnFilterAlleSelektiert() {

        // Lsche die Selektion und Input der Tabelle:
        loescheSelektion();
        _listeBastDatenObjekteGefiltert = new ArrayList<BastDatenObjekt>();

        // Schalte den Filter aus:
        _istFilter = false;

        // Setze neue Input der Tabelle:
        setzeTabellenInput();
    }

    /**
     * Button 'Filter Fehlende' wird selektiert.
     */
    protected void btnFilterFehlendeSelektiert() {

        // Lsche die Selektion und Input der Tabelle:
        loescheSelektion();

        // Erstelle und setze neue Input der Tabelle:
        _listeBastDatenObjekteGefiltert = new ArrayList<BastDatenObjekt>();

        for (BastDatenObjekt dat : _listeBastDatenObjekte) {
            if (istBastDatenObjektMitFehler(dat)) {
                _listeBastDatenObjekteGefiltert.add(dat);
            }
        }

        // Schalte den Filter ein:
        _istFilter = true;

        // Setze neue Input der Tabelle:
        setzeTabellenInput();
    }

    /**
     * Button 'Filter Selektierte' wird selektiert.
     */
    protected void btnFilterSelektierteSelektiert() {

        // Lsche Input der Tabelle:
        // Erstelle und setze neue Input der Tabelle:
        List<BastDatenObjekt> listeSelektiert = new ArrayList<BastDatenObjekt>();

        for (int i : _listeAusgewaehlterZeilen) {
            if (_istFilter) {
                listeSelektiert.add(_listeBastDatenObjekteGefiltert.get(i));
            } else {
                listeSelektiert.add(_listeBastDatenObjekte.get(i));
            }
        }

        _listeBastDatenObjekteGefiltert = new ArrayList<BastDatenObjekt>();
        _listeBastDatenObjekteGefiltert.addAll(listeSelektiert);

        // Schalte den Filter ein:
        _istFilter = true;

        // Setze neue Input der Tabelle:
        setzeTabellenInput();

        // Selektiere alle:
        _listeAusgewaehlterZeilen = new ArrayList<Integer>();
        btnSelektionAlleSelektiert();
    }

    /**
     * Die Taste "LangzeitzaehlstellenAuswahl"  wird selektiert.
     * <p>
     * Die Menge der selektierten Langzeitzaehlstellen wird gesetzt.
     * </p>
     */
    protected void btnLangzeitzaehlstellenAuswahlSelektiert() {
        _listeLzz = LangzeitzaehlstellenAuswahlFunktionen.langzeitZaehlstellenAuswahlDialogOeffnen(_gui.getShell(), _listeLzz, null);

        // Zeige im GUI, wie viel Langzeitzaehlstellen sind selektiert:
        zeigeAnzahlSelLangzeitzaehlstellen();
    }

    /**
     * Button 'Selektion Alle' wird selektiert.
     */
    protected void btnSelektionAlleSelektiert() {
        for (TableItem zeile : _gui.getTableViewer().getTable().getItems()) {
            zeile.setChecked(true);
        }

        cbtnAuswahlSelektiert();
    }

    /**
     * Button 'Selektion Fehlende' wird selektiert.
     */
    protected void btnSelektionFehlendeSelektiert() {
        boolean               istFehler;
        List<BastDatenObjekt> listeDat;

        if (_istFilter) {
            listeDat = _listeBastDatenObjekteGefiltert;
        } else {
            listeDat = _listeBastDatenObjekte;
        }

        for (int i = 0; i < listeDat.size(); i++) {
            istFehler = istBastDatenObjektMitFehler(listeDat.get(i));
            _gui.getTableViewer().getTable().getItem(i).setChecked(istFehler);
        }

        cbtnAuswahlSelektiert();
    }

    /**
     * Button 'Selektion Keine' wird selektiert.
     */
    protected void btnSelektionKeineSelektiert() {
        for (TableItem zeile : _gui.getTableViewer().getTable().getItems()) {
            zeile.setChecked(false);
        }

        cbtnAuswahlSelektiert();
    }

    /**
     * Die Schaltflche "Tabelle neu laden"  wird selektiert.
     * </p>
     * Tabelle wird neu geladen.
     */
    protected void btnTabelleNeuLadenSelektiert() {

        // ----------------------------------------------
        // Prfe den Zeitbereich:
        long von = _gui.getDatumVon().ermittleDatumZeit();

        von = DatumFunktionen.getMonatAnfang(von);

        long bis = _gui.getDatumBis().ermittleDatumZeit();

        bis = DatumFunktionen.getMonatEnde(bis);

        if (von > bis) {
            MessageDialog.openError(_gui.getShell(), "Fehler",  //
                                    "Anfang des Zeitbereichs ist grer als das Ende. Bitte korrigieren sie zuerst die Zeitbereichsangabe!");

            return;
        }

        // ----------------------------------------------
        // Flle die Tabelle:
        fuelleTabelle();

        // ----------------------------------------------
        // Speichere Tabellen-Einstellungen:
        // von-bis:
        _tabelleVon = formatiereDatum(von);
        _tabelleBis = formatiereDatum(bis);

        // BASt-Format:
        if (_gui.getRbtnBast2004().getSelection()) {
            _tabelleBastFormat = "2004";
        } else {
            _tabelleBastFormat = "2007";
        }

        // LZZ:
        _tabelleListeLzz = new ArrayList<ZaehlStelle>();
        _tabelleListeLzz.addAll(_listeLzz);

        // ----------------------------------------------
        setzeEnabledWerteFuerButtons();

        // ----------------------------------------------
        btnFilterAlleSelektiert();
        btnSelektionKeineSelektiert();
    }

    /**
     * Die Schaltflche "Vollstndige Prfung"  wird selektiert.
     */
    protected void btnVollstaendigePruefungSelektiert() {

        // -----------------------------------------------------------------------
        // Ermittle Liste mit dem Inhalt der Tabelle:
        final List<BastDatenObjekt> listeDat;

        if (_istFilter) {
            listeDat = _listeBastDatenObjekteGefiltert;
        } else {
            listeDat = _listeBastDatenObjekte;
        }

        // -----------------------------------------------------------------------
        final DataDescription dd;

        if (_gui.getRbtnBast2004().getSelection()) {
            dd = _dataDescription2004;
        } else {
            dd = _dataDescription2007;
        }

        // --------------------------------------------------------------------------------
        // Erstelle den WartenDialog:
        final ProgressMonitorDialog dialog = new ProgressMonitorDialog(Display.getDefault().getActiveShell()) {
            @Override
            protected void createCancelButton(Composite parent) {
                super.createCancelButton(parent);
                getButton(CANCEL).setText("Abbrechen");
                getButton(CANCEL).setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
            }
        };

        // --------------------------------------------------------------------------------
        // ffne den WartenDialog:
        final int anzZeilen = _listeAusgewaehlterZeilen.size();
        final int anzTagen  = anzZeilen * _listeMonate.size() * 30;

        try {
            dialog.run(true, true, new IRunnableWithProgress() {
                @Override
                public void run(IProgressMonitor monitor) throws InvocationTargetException, InterruptedException {
                    monitor.beginTask("Vollstndige Archivanfrage luft ...", anzTagen);

                    //
                    boolean istAbgebrochen = false;

                    // --------------------------------------------------------------------------------
                    // Archivanfrage fr selektierte BastDatenObjekt und alle Stunden fr alle Monate
                    // -------------------------------
                    // Betrachte alle selektierte BastDatenObjekt:
                    int             zeile = -1;
                    BastDatenObjekt dat;

                    for (int indexSelektiert : _listeAusgewaehlterZeilen) {

                        //
                        dat = listeDat.get(indexSelektiert);

                        //
                        zeile++;

                        // Kein Archiv:
                        if (!_dav.getArchive().isArchiveAvailable()) {
                            String meldung = String.format("Das Archiv ist zur Zeit nicht verfgbar! Es wurden %d von %d Zeilen bearbeitet.", zeile, anzZeilen);

                            monitor.subTask(meldung);
                            Thread.sleep(3000);
                            Log.zeige(Log.erzeugeMeldung(Log.WARNUNG, Activator.PLUGIN_ID, meldung));

                            break;
                        }

                        // Abbruch:
                        if (istAbgebrochen) {
                            break;
                        }

                        // -------------------------------
                        // Betrachte alle Monate:
                        for (int i = 0; i < _listeMonate.size(); i++) {

                            // Abbruch:
                            if (istAbgebrochen) {
                                break;
                            }

                            // -------------------------------
                            // Betrachte alle Tage und Stunden des Monats:
                            long   tagStunde = _listeMonate.get(i);
                            int    monat     = DatumFunktionen.getMonat(tagStunde);
                            int    anzWorked = 0;
                            int    anzOk     = 0;
                            int    anzFehler = 0;
                            Status status;

                            // Definiere am Anfang der Status als <ok>,
                            // und falls whrend der Prfung einmal <fehler> vorkommt,
                            // wird der Status neu definiert:
                            dat._arMonatenStatus[i] = Status.OK;

                            while (DatumFunktionen.getMonat(tagStunde) == monat) {

                                // Abbruch wird gedruckt:
                                if (monitor.isCanceled()) {
                                    istAbgebrochen = true;

                                    break;
                                }

                                //
                                if ((anzOk + anzFehler) % 24 == 0) {
                                    anzWorked++;
                                    monitor.worked(1);
                                    monitor.subTask(String.format("%s -- %s -- %s", dat._zs.getSystemObjekt().getNameOrPidOrId(),  //
                                                                  dat._fs.getSystemObjekt().getNameOrPidOrId(),                    //
                                                                  DatumFunktionen.getDatumZeitOhneSekundenAlsString(tagStunde)));
                                }

                                // Ermittle Status:
                                status = archivAnfrageBastDaten(dat._fs.getSystemObjekt(), dd, tagStunde);

                                if (status == Status.OK) {
                                    anzOk++;
                                } else {
                                    anzFehler++;
                                }

                                // Nchste Stunde:
                                tagStunde = tagStunde + 60 * 60 * 1000;
                            }

                            // Setze beim Abruch den Status auf <fehler>:
                            if (istAbgebrochen) {
                                dat._vollPruefung       = false;
                                dat._arMonatenStatus[i] = Status.FEHLER;
                            }

                            // Speichere Ergebnis:
                            else {
                                dat._vollPruefung              = true;
                                dat._arStundenOkImMonat[i]     = anzOk;
                                dat._arStundenFehlerImMonat[i] = anzFehler;

                                double prozentMitOk = 100.0 * anzOk / (anzOk + anzFehler);

                                if (prozentMitOk == 0) {
                                    dat._arMonatenStatus[i] = Status.FEHLER;
                                } else if (prozentMitOk < 50) {
                                    dat._arMonatenStatus[i] = Status.UNTER_50;
                                } else if (prozentMitOk < 100) {
                                    dat._arMonatenStatus[i] = Status.UEBER_50;
                                } else {
                                    dat._arMonatenStatus[i] = Status.OK;
                                }
                            }

                            // Balke:
                            if ((30 - anzWorked) > 0) {
                                monitor.worked(30 - anzWorked);
                            }
                        }
                    }

                    // --------------------------------------------------------------------------------
                    // Abbruch:
                    if (istAbgebrochen) {
                        String meldung = String.format("Die Archivanfrage wurde abgebrochen! Es wurden %d von %d Zeilen bearbeitet.", zeile, anzZeilen);

                        monitor.subTask(meldung);
                        Thread.sleep(3000);
                        Log.zeige(Log.erzeugeMeldung(Log.WARNUNG, Activator.PLUGIN_ID, meldung));
                    }

                    // --------------------------------------------------------------------------------
                    // Schliesse den WartenDialog
                    monitor.done();
                }
            });
        }
        catch (Exception e) {
            Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Fehler bei der Archivanfrage", e));
        }

        // -----------------------------------------------------------------------
        // Setze neue Input der Tabelle:
        setzeTabellenInput();
    }

    /**
     * Check-Button 'Auswahl' aus der Tabelle wird selektiert.
     */
    private void cbtnAuswahlSelektiert() {
        _listeAusgewaehlterZeilen = new ArrayList<Integer>();

        int i = 0;

        for (TableItem zeile : _gui.getTableViewer().getTable().getItems()) {
            if (zeile.getChecked()) {
                _listeAusgewaehlterZeilen.add(i);
            }

            i++;
        }

        //
        _gui.getBtnVollstaendigePruefung().setEnabled(!_listeAusgewaehlterZeilen.isEmpty());
    }

    /**
     * Ermittle Info fr angegebene Status-Anzeige.
     *
     * @param status Status-Anzeige.
     *
     * @return Info fr angegebene Status-Anzeige oder leeres String.
     */
    private String ermittleInfo(String status) {
        try {
            String[] ar = status.split(" ");

            return String.format("%s Stunden des Monats liegen vor, %s Stunden fehlen", ar[0], ar[3]);
        }
        catch (Exception e) {
            return "";
        }
    }

    /**
     * Exportiere eine Zeile in die Datei.
     *
     * @param out FileWriter.
     * @param arZeile Array mit dem Zeileninhalt.
     *
     * @throws Exception Exception.
     */
    private void exportAusgabe(FileWriter out, String[] arZeile) throws Exception {
        for (String zelle : arZeile) {
            out.write(zelle);
            out.write(TRENNZEICHEN);
        }

        out.write(NEWLINE);
    }

    /**
     * Formatiere das angegebene Datum.
     *
     * @param datum Datum.
     *
     * @return Formatiertes Datum in der Form "mm.jjjj".
     */
    private String formatiereDatum(long datum) {
        return String.format("%02d.%d", DatumFunktionen.getMonat(datum), DatumFunktionen.getJahr(datum));
    }

    /**
     * Formatiere die Status-Anzeige.
     *
     * @param dat BastDatenObjekt.
     * @param indexMonat Index von Monat.
     *
     * @return Formatiere Status-Anzeige.
     */
    private String formatiereStatusAnzeige(BastDatenObjekt dat, int indexMonat) {
        if (dat._vollPruefung) {
            return String.format("%d ok - %d F", dat._arStundenOkImMonat[indexMonat], dat._arStundenFehlerImMonat[indexMonat]);
        } else {
            return dat._arMonatenStatus[indexMonat]._status;
        }
    }

    /**
     * Erstelle den Inhalt der Tabelle und flle die.
     */
    private void fuelleTabelle() {
        _listeBastDatenObjekte = new ArrayList<BastDatenObjekt>();

        // -----------------------------------------------
        // Erstelle die Liste der Monate:
        _listeMonate = new ArrayList<Long>();

        long von = _gui.getDatumVon().ermittleDatumZeit();
        long bis = _gui.getDatumBis().ermittleDatumZeit();

        bis = DatumFunktionen.getMonatAnfang(bis);

        long monatStart = DatumFunktionen.getMonatAnfang(von);

        while (monatStart <= bis) {
            _listeMonate.add(monatStart);
            monatStart = DatumFunktionen.getVerschobenenDateTime(monatStart, 1, 0);
        }

        // -----------------------------------------------
        // Erstelle die Input-Liste:
        // -----------------------------------------------
        // Fr jede selektierte ZaehlStelle:
        for (ZaehlStelle zs : _listeLzz) {

            // -----------------------------------------------
            // Ermittle alle FS:
            List<Fahrbahnen> listeFs = new ArrayList<Fahrbahnen>();

            for (Fahrbahnen fs : zs.ermittleArFsInRichtung()) {
                listeFs.add(fs);
            }

            for (Fahrbahnen fs : zs.ermittleArFsGegenRichtung()) {
                listeFs.add(fs);
            }

            // -----------------------------------------------
            // Fr jede Fahrbahn:
            for (Fahrbahnen fs : listeFs) {
                _listeBastDatenObjekte.add(new BastDatenObjekt(zs, fs, _listeMonate.size()));
            }
        }

        // -----------------------------------------------
        // Sortiere die Liste:
        // -----------------------------------------------
        Collections.sort(_listeBastDatenObjekte, new Comparator<BastDatenObjekt>() {
            @Override
            public int compare(BastDatenObjekt dat1, BastDatenObjekt dat2) {

                // Sortierung DZ (Zhlstellen) und FS (Fahrstreifen):
                // DZ:
                String dz1 = dat1._zs.getSystemObjekt().getNameOrPidOrId();
                String dz2 = dat2._zs.getSystemObjekt().getNameOrPidOrId();

                if (dz1.equals(dz2)) {

                    // FS:
                    String f1 = dat1._fs.getSystemObjekt().getNameOrPidOrId();
                    String f2 = dat2._fs.getSystemObjekt().getNameOrPidOrId();

                    return f1.compareTo(f2);
                } else {
                    return dz1.compareTo(dz2);
                }
            }
        });

        // -----------------------------------------------
        // Archivanfrage:
        // -----------------------------------------------
        archivAnfrageBastDaten();

        // -----------------------------------------------
        // Definiere die TabellenStruktur und setze den TabellenInput:
        // -----------------------------------------------
        initTabelle();

        //
        Display.getDefault().syncExec(new Runnable() {
            @Override
            public void run() {
                _gui.getTableViewer().setInput(_listeBastDatenObjekte);

                for (int i = 0; i < AR_SPALTEN_NAMEN_FEST.length; i++) {
                    _gui.getTableViewer().getTable().getColumn(i).pack();
                }
            }
        });
    }

    /**
     * Initialisiere das GUI.
     */
    protected void initGui() {

        // -------------------------------------------------
        // Typ und Aspekt:
        _gui.getTxtTyp().setText(TYP);
        _gui.getTxtAsp().setText(ASPEKT);

        // -------------------------------------------------
        // Selektiere BASt-Format:
        _gui.getRbtnBast2004().setSelection(true);
        _gui.getRbtnBast2007().setSelection(false);
        rbtnBastFormatSelektiert();

        // -------------------------------------------------
        // Inititialisiere die Liste der Langzeitzaehlstellen mit den
        // im Baum selektierten Langzeitzaehlstellen.
        List<ZaehlStelle> alleAusgewaehltenZaehlStellen = SelektionVew.getInstanz().ermittleListeSelektierterZaehlStellen();

        _listeLzz.addAll(alleAusgewaehltenZaehlStellen);
        zeigeAnzahlSelLangzeitzaehlstellen();

        // -------------------------------------------------
        // Initialisiere Tabelle:
        _gui.getTableViewer().setContentProvider(new ArrayContentProvider());
        _gui.getTableViewer().setLabelProvider(new TableLabelProvider());

        // SelectionListener fr die Checkboxen:
        _gui.getTableViewer().getTable().addSelectionListener(new SelectionListener() {
            @Override
            public void widgetDefaultSelected(SelectionEvent e) {}
            @Override
            public void widgetSelected(SelectionEvent e) {
                cbtnAuswahlSelektiert();
            }
        });

        // Tabelle:
        initTabelle();

        // Buttons:
        setzeEnabledWerteFuerButtons();
        _gui.getBtnVollstaendigePruefung().setEnabled(false);
        _gui.getBtnExport().setEnabled(false);
    }

    /**
     * Initialisiere die Tabelle.
     */
    private void initTabelle() {
        Table table = _gui.getTableViewer().getTable();

        // Lsche alte Daten:
        table.clearAll();

        for (TableColumn tabcol : table.getColumns()) {
            tabcol.dispose();
        }

        // Feste Spalten:
        for (int i = 0; i < AR_SPALTEN_NAMEN_FEST.length; i++) {
            TableColumn tabcol = new TableColumn(table, SWT.NONE, i);

            tabcol.setText(AR_SPALTEN_NAMEN_FEST[i]);
            tabcol.setWidth(100);
        }

        // Spalten mit Monat-Angaben:
        for (long monat : _listeMonate) {
            TableColumn tabcol = new TableColumn(table, SWT.NONE);

            tabcol.setText(formatiereDatum(monat));
            tabcol.setWidth(80);
            tabcol.setAlignment(SWT.CENTER);
        }
    }

    /**
     * Stellt fest, ob das BastDatenObjekt mit Fehler ist.
     *
     * @param dat BastDatenObjekt.
     *
     * @return true, falls das BastDatenObjekt mit Fehler ist,
     * false - sonst.
     */
    private boolean istBastDatenObjektMitFehler(BastDatenObjekt dat) {
        boolean istFehler = false;

        for (Status st : dat._arMonatenStatus) {
            if (st != Status.OK) {
                istFehler = true;

                break;
            }
        }

        return istFehler;
    }

    /**
     * Lsche die Selektion in der Tabelle
     */
    private void loescheSelektion() {
        _listeAusgewaehlterZeilen = new ArrayList<Integer>();

        for (TableItem zeile : _gui.getTableViewer().getTable().getItems()) {
            zeile.setChecked(false);
        }

        //
        _gui.getBtnVollstaendigePruefung().setEnabled(!_listeAusgewaehlterZeilen.isEmpty());
    }

    /**
     * Maus ber der Tabelle.
     *
     * @param e MouseEvent.
     */
    protected void mausUeberTabelle(MouseEvent e) {

        // Lsche alten Tooltip (da sonst, bis neuen berechnet wird, alten Text angezeigt wird):
        _gui.getTableViewer().getTable().setToolTipText(null);

        // Zeige Tooltip:
        String text = null;

        try {
            TableItem zeile        = _gui.getTableViewer().getTable().getItem(new Point(e.x, e.y));
            boolean   vollPruefung = zeile.getText(0).equals(VOLLSTAENDIG_GEPRUEFT);

            //
            for (int i = 0; i < _gui.getTableViewer().getTable().getColumnCount(); i++) {
                Rectangle spalte = zeile.getTextBounds(i);

                if (e.x < spalte.x + spalte.width) {

                    // Spalte 0:
                    if (i == 0) {
                        if (vollPruefung) {
                            text = "Der Fahrstreifen wurde vollstndig geprft.";
                        } else {
                            text = "Es wurde die schnelle Prfung fr den Fahrstreifen durchgefhrt.";
                        }

                        break;
                    }

                    // Spalten 1, 2:
                    else if ((i == 1) || (i == 2)) {
                        text = zeile.getText(i);

                        break;
                    }

                    // Spalten mit Status:
                    else {
                        String wert = zeile.getText(i);

                        if (vollPruefung) {
                            text = String.format("%s %s.", ERGEBNIS_VOLLSTAENDIGE_PRUEFUNG, ermittleInfo(wert));
                        } else {
                            text = String.format("%s %s.", ERGEBNIS_SCHNELLE_PRUEFUNG, Status.ermittleInfo(wert));
                        }

                        break;
                    }
                }
            }
        }
        catch (Exception ignored) {}

        // Tooltip:
        _gui.getTableViewer().getTable().setToolTipText(text);
    }

    /**
     * Radio-Button 'BASt-Format' wird selektiert.
     */
    protected void rbtnBastFormatSelektiert() {

        // 2004:
        if (_gui.getRbtnBast2004().getSelection()) {
            _gui.getTxtAtg().setText(ATG_2004);
        }

        // 2007:
        else {
            _gui.getTxtAtg().setText(ATG_2007);
        }
    }

    /**
     *  Setze EnabledWerte fr die Buttons 'Steuerung der Tabellenanzeige'.
     */
    private void setzeEnabledWerteFuerButtons() {
        boolean wert = !_listeBastDatenObjekte.isEmpty();

        _gui.getBtnSelektionAlle().setEnabled(wert);
        _gui.getBtnSelektionFehlende().setEnabled(wert);
        _gui.getBtnSelektionKeine().setEnabled(wert);
        _gui.getBtnFilterAlle().setEnabled(wert);
        _gui.getBtnFilterFehlende().setEnabled(wert);
        _gui.getBtnFilterSelektierte().setEnabled(wert);
    }

    /**
     * Setze Tabellen-Input.
     */
    private void setzeTabellenInput() {
        List<BastDatenObjekt> liste;

        if (_istFilter) {
            liste = _listeBastDatenObjekteGefiltert;
        } else {
            liste = _listeBastDatenObjekte;
        }

        _gui.getTableViewer().setInput(liste);

        //
        _gui.getBtnExport().setEnabled(!liste.isEmpty());
    }

    /**
     * Zeige im GUI, wie viele Langzeitzaehlstellen selektiert sind.
     */
    private void zeigeAnzahlSelLangzeitzaehlstellen() {
        String text;

        if (_listeLzz.size() == 0) {
            text = "Es ist keine Langzeitzhlstelle ausgewhlt.";
        } else {
            text = String.format("Anzahl der selektierten Langzeitzhlstellen: %d", _listeLzz.size());
        }

        _gui.getLbLangZeitZaehlStellenAuswahl().setText(text);
        _gui.getLbLangZeitZaehlStellenAuswahl().getParent().layout();

        // Funktion 'Tabelle neu laden' wird erlaubt, nur wenn mindestenz eine
        // Langzeitzaehlstelle selektiert ist:
        _gui.getBtnTablNeuLaden().setEnabled((_listeLzz.size() > 0) && (DavArchivVew.getInstanz().istArchivVerfuegbar()));
    }

    //~ INNERE KLASSEN ========================================================

    /**
     * Klasse beschreibt ein Objekt mit BastDaten.
     * Ein BastDatenObjekt wird in einer Zeile der Tabelle dargestellt.
     *
     * @author inovat
     * @author Liliya Givorgizova (LG)
     * @version $Revision: 211 $ / $Date: 2012-10-09 11:50:12 +0200 (Di, 09. Okt 2012) $ / ($Author: LG $)
     */
    class BastDatenObjekt {

        /** Stellt fest, ob die Vollstndige Prfung durchgefhrt wurde. */
        private boolean  _vollPruefung = false;
        private Status[] _arMonatenStatus;

        /** Anzahl der Stunden im Monat mit dem Status _Fehler. */
        private int[] _arStundenFehlerImMonat;

        /** Anzahl der Stunden im Monat mit dem Status OK. */
        private int[]       _arStundenOkImMonat;
        private Fahrbahnen  _fs;
        private ZaehlStelle _zs;

        //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==========

        /**
         * Erzeugt eine Instanz der Klasse BastDatenObjekt.
         *
         * @param zs ZaehlStelle.
         * @param fs Fahrbahnen.
         * @param anzMonaten Anzahl der Monaten.
         */
        private BastDatenObjekt(ZaehlStelle zs, Fahrbahnen fs, int anzMonaten) {
            _zs = zs;
            _fs = fs;

            //
            _arMonatenStatus = new Status[anzMonaten];

            for (int i = 0; i < anzMonaten; i++) {
                _arMonatenStatus[i] = Status.FEHLER;
            }

            //
            _arStundenOkImMonat     = new int[anzMonaten];
            _arStundenFehlerImMonat = new int[anzMonaten];
        }
    }


    /**
     * LabelProvider fr die Tabelle.
     */
    class TableLabelProvider implements ITableLabelProvider, ITableColorProvider {
        @Override
        public void addListener(ILabelProviderListener listener) {}

        @Override
        public void dispose() {}

        //~ GET METHODEN ======================================================

        @Override
        public Color getBackground(Object element, int columnIndex) {
            int indexErsteStatusSpalte = AR_SPALTEN_NAMEN_FEST.length;

            if (columnIndex >= indexErsteStatusSpalte) {
                if (element instanceof BastDatenObjekt) {
                    BastDatenObjekt dat = (BastDatenObjekt) element;

                    return dat._arMonatenStatus[columnIndex - indexErsteStatusSpalte]._farbe;
                }
            }

            return null;
        }

        @Override
        public Image getColumnImage(Object element, int columnIndex) {
            return null;
        }

        @Override
        public String getColumnText(Object element, int columnIndex) {
            if (element instanceof BastDatenObjekt) {
                BastDatenObjekt dat = (BastDatenObjekt) element;

                switch (columnIndex) {
                case 0 :
                    if (dat._vollPruefung) {
                        return VOLLSTAENDIG_GEPRUEFT;
                    } else {
                        return "";
                    }
                case 1 :
                    return dat._zs.getSystemObjekt().getNameOrPidOrId();

                case 2 :
                    return dat._fs.getSystemObjekt().getNameOrPidOrId();
                }

                int indexErsteStatusSpalte = AR_SPALTEN_NAMEN_FEST.length;

                try {
                    int indexMonat = columnIndex - indexErsteStatusSpalte;

                    return formatiereStatusAnzeige(dat, indexMonat);
                }
                catch (Exception e) {
                    e.printStackTrace();
                }
            }

            return "???";
        }

        @Override
        public Color getForeground(Object element, int columnIndex) {
            return null;
        }

        @Override
        public boolean isLabelProperty(Object element, String property) {
            return false;
        }

        //~ METHODEN ==========================================================

        @Override
        public void removeListener(ILabelProviderListener listener) {}
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 22.10.13
