/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.lzzs;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.plugin.gtm.lzzs.aktionen.AktionenLZZS;
import de.inovat.buv.plugin.gtm.lzzs.hilfe.HilfeVew;
import de.inovat.buv.plugin.gtm.lzzs.pufferabruf.PufferabrufGUI;
import de.inovat.buv.plugin.gtm.navigation.lib.AuswahlDialogGUI.ZS_MODUS;
import de.inovat.buv.projektlib.rechtevew.aktionen.AbstrakteSichtMitBerechtigung;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

//~ KLASSEN ===================================================================

/**
 * Sicht fr die Pufferabfrage Achslastdaten.
 *
 * @author inovat
 * @author Dagmar Rostek (DR)
 * @version $Revision: 174 $ / $Date: 2012-09-12 17:04:43 +0200 (Mi, 12 Sep 2012) $ / ($Author: LG $)
 */
public class ViewPufferAXL extends AbstrakteSichtMitBerechtigung {

    /** ID der Sicht 'Pufferabruf Achslastmessstellen'. */
    public static final String ID = "de.inovat.buv.plugin.gtm.lzzs.pufferAXL.view";

    //~ FELDER ================================================================

    /** GUI Pufferabruf Instanz. */
    private PufferabrufGUI _gui;

    //~ METHODEN ==============================================================

    @Override
    public void dispose() {
        if (_gui != null) {
            if (_gui.getToolkit() != null) {
                _gui.getToolkit().dispose();
            }
        }

        super.dispose();
    }

    //~ GET METHODEN ==========================================================

    @Override
    public String getBerechtigungsFunktionId() {
        return AktionenLZZS.FUNKTION_ID_PUFFER_AXL;
    }

    @Override
    public String getHilfeContextId() {
        return HilfeVew.getInstanz().ermittleIdFuerAnker(HilfeVew.ANKER_PUFFERABRUF);
    }

    //~ METHODEN ==============================================================

    @Override
    public Control initGUI(Composite parent) {
        _gui = new PufferabrufGUI(parent, ZS_MODUS.AXL);

        return _gui;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 28.10.13
