/*
 * @(#)AggregationDtvGUI.java   17.09.10
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.lzzs.aggregation;

//~ NICHT JDK IMPORTE =========================================================

import de.bsvrz.buv.rw.basislib.kalender.DatumZeit;
import de.bsvrz.dav.daf.main.ClientReceiverInterface;
import de.bsvrz.dav.daf.main.ClientSenderInterface;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.ResultData;

import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;

//~ KLASSEN ===================================================================

/**
 * GUI fr die Sicht 'Aggregation DTV'.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 88 $ / $Date: 2012-03-09 16:20:38 +0100 (Fr, 09 Mrz 2012) $ / ($Author: LG $)
 */
public class AggregationDtvGUI extends Composite implements ClientReceiverInterface, ClientSenderInterface {

    /** FormToolkit. */
    private final FormToolkit _toolkit = new FormToolkit(Display.getCurrent());
    private Button            _btnSchliessen;
    private Button            _btnSenden;
    private Button            _cbtnDtvJahr;
    private Button            _cbtnDtvMonat;
    private Button            _cbtnDtvQuartal;
    private Button            _cbtnDtvTag;
    private Button            _cbtnMsvJahr;
    private DatumZeit         _dzBis;
    private DatumZeit         _dzVon;

    /** Instanz GUI-Verwaltung. */
    private AggregationDtvGUIVew _guiVew;
    private Label                _lbZaehlstellenAnzahl;
    private ProgressBar          _prgFortschrittsanzeige;
    private Section              _sectionSteuerung;
    private Text                 _txtMeldungen;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Erzeugt eine Instanz der Klasse AggregationDtvGUI.
     *
     * @param parent Parent-Composite.
     */
    public AggregationDtvGUI(Composite parent) {
        super(parent, SWT.NONE);

        //
        _guiVew = new AggregationDtvGUIVew(this);

        //
        _toolkit.adapt(this);
        _toolkit.paintBordersFor(this);

        //
        initGUI();

        //
        _guiVew.initialisiereGui();

        // Melde das GUI auf die nderungen von AggregationDtvStatus und AggregationDtvSteuerung an:
        _guiVew.anmeldenAggregationDtvAufSendenUndEmfang();
    }

    //~ METHODEN ==============================================================

    @Override
    public void dataRequest(SystemObject object, DataDescription dataDescription, byte state) {

        // nicht tun, da keine Sender-Steuerung.
    }

    //~ GET METHODEN ==========================================================

    /**
     * Getter fr Eigenschaft 'btnSenden'.
     *
     * @return Wert der Eigenschaft 'btnSenden'.
     *
     * @see #_btnSenden
     */
    public Button getBtnSenden() {
        return _btnSenden;
    }

    /**
     * Getter fr Eigenschaft 'cbtnDtvJahr'.
     *
     * @return Wert der Eigenschaft 'cbtnDtvJahr'.
     *
     * @see #_cbtnDtvJahr
     */
    public Button getCbtnDtvJahr() {
        return _cbtnDtvJahr;
    }

    /**
     * Getter fr Eigenschaft 'cbtnDtvMonat'.
     *
     * @return Wert der Eigenschaft 'cbtnDtvMonat'.
     *
     * @see #_cbtnDtvMonat
     */
    public Button getCbtnDtvMonat() {
        return _cbtnDtvMonat;
    }

    /**
     * Getter fr Eigenschaft 'cbtnDtvQuartal'.
     *
     * @return Wert der Eigenschaft 'cbtnDtvQuartal'.
     *
     * @see #_cbtnDtvQuartal
     */
    public Button getCbtnDtvQuartal() {
        return _cbtnDtvQuartal;
    }

    /**
     * Getter fr Eigenschaft 'cbtnDtvTag'.
     *
     * @return Wert der Eigenschaft 'cbtnDtvTag'.
     *
     * @see #_cbtnDtvTag
     */
    public Button getCbtnDtvTag() {
        return _cbtnDtvTag;
    }

    /**
     * Getter fr Eigenschaft 'cbtnMsvJahr'.
     *
     * @return Wert der Eigenschaft 'cbtnMsvJahr'.
     *
     * @see #_cbtnMsvJahr
     */
    public Button getCbtnMsvJahr() {
        return _cbtnMsvJahr;
    }

    /**
     * Getter fr Eigenschaft 'dzBis'.
     *
     * @return Wert der Eigenschaft 'dzBis'.
     *
     * @see #_dzBis
     */
    public DatumZeit getDzBis() {
        return _dzBis;
    }

    /**
     * Getter fr Eigenschaft 'dzVon'.
     *
     * @return Wert der Eigenschaft 'dzVon'.
     *
     * @see #_dzVon
     */
    public DatumZeit getDzVon() {
        return _dzVon;
    }

    /**
     * Getter fr Eigenschaft 'guiVew'.
     *
     * @return Wert der Eigenschaft 'guiVew'.
     *
     * @see #_guiVew
     */
    public AggregationDtvGUIVew getGuiVew() {
        return _guiVew;
    }

    /**
     *     Getter fr Eigenschaft 'lbZaehlstellenAnzahl'.
     *
     *     @return Wert der Eigenschaft 'lbZaehlstellenAnzahl'.
     *
     *     @see #_lbZaehlstellenAnzahl
     */
    public Label getLbZaehlstellenAnzahl() {
        return _lbZaehlstellenAnzahl;
    }

    /**
     * Getter fr Eigenschaft 'prgFortschrittsanzeige'.
     *
     * @return Wert der Eigenschaft 'prgFortschrittsanzeige'.
     *
     * @see #_prgFortschrittsanzeige
     */
    public ProgressBar getPrgFortschrittsanzeige() {
        return _prgFortschrittsanzeige;
    }

    /**
     * Getter fr Eigenschaft 'sectionSteuerung'.
     *
     * @return Wert der Eigenschaft 'sectionSteuerung'.
     *
     * @see #_sectionSteuerung
     */
    public Section getSectionSteuerung() {
        return _sectionSteuerung;
    }

    /**
     * Getter fr Eigenschaft 'toolkit'.
     *
     * @return Wert der Eigenschaft 'toolkit'.
     *
     * @see #_toolkit
     */
    public FormToolkit getToolkit() {
        return _toolkit;
    }

    /**
     * Getter fr Eigenschaft 'txtMeldungen'.
     *
     * @return Wert der Eigenschaft 'txtMeldungen'.
     *
     * @see #_txtMeldungen
     */
    public Text getTxtMeldungen() {
        return _txtMeldungen;
    }

    //~ METHODEN ==============================================================

    /**
     * Initialisiere das GUI.
     */
    private void initGUI() {
        GridLayout gridLayout = new GridLayout(1, false);

        gridLayout.marginWidth  = 0;
        gridLayout.marginHeight = 0;
        setLayout(gridLayout);

        ScrolledComposite scompAll = new ScrolledComposite(this, SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL);

        scompAll.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
        scompAll.setExpandHorizontal(true);
        scompAll.setExpandVertical(true);

        Composite  compAll    = new Composite(scompAll, SWT.NONE);
        GridLayout gl_compAll = new GridLayout(1, false);

        gl_compAll.marginWidth  = 0;
        gl_compAll.marginHeight = 0;
        compAll.setLayout(gl_compAll);

        ScrolledForm scrolledForm = _toolkit.createScrolledForm(compAll);

        scrolledForm.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
        _toolkit.paintBordersFor(scrolledForm);
        scrolledForm.getBody().setLayout(new GridLayout(1, false));

        //
        _sectionSteuerung = _toolkit.createSection(scrolledForm.getBody(), Section.TWISTIE | Section.TITLE_BAR);
        _sectionSteuerung.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        _toolkit.paintBordersFor(_sectionSteuerung);
        _sectionSteuerung.setText("Steuerung");

        Composite compSteuerung = _toolkit.createComposite(_sectionSteuerung, SWT.NONE);

        _toolkit.paintBordersFor(compSteuerung);
        _sectionSteuerung.setClient(compSteuerung);
        compSteuerung.setLayout(new GridLayout(1, false));

        Composite compAggr = _toolkit.createComposite(compSteuerung, SWT.NONE);

        compAggr.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
        _toolkit.paintBordersFor(compAggr);
        compAggr.setLayout(new GridLayout(2, false));
        _toolkit.createLabel(compAggr, "Zeitbereichsangabe:", SWT.NONE);

        Composite compZeitintervall = _toolkit.createComposite(compAggr, SWT.NONE);

        compZeitintervall.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        _toolkit.paintBordersFor(compZeitintervall);
        compZeitintervall.setLayout(new GridLayout(4, false));
        _toolkit.createLabel(compZeitintervall, "von", SWT.NONE);

        //
        _dzVon = new DatumZeit(compZeitintervall, SWT.BORDER, DatumZeit.Eingabetyp.datum, false, false);

        GridData gd_dzVon = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);

        gd_dzVon.widthHint = 120;
        _dzVon.setLayoutData(gd_dzVon);
        _toolkit.adapt(_dzVon);
        _toolkit.paintBordersFor(_dzVon);
        _dzVon.hinzufuegenSelektionsZuhoerer(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                _guiVew.dzDatumSelektiert();
            }
        });

        //
        _toolkit.createLabel(compZeitintervall, "bis", SWT.NONE);

        //
        _dzBis = new DatumZeit(compZeitintervall, SWT.BORDER, DatumZeit.Eingabetyp.datum, false, false);

        GridData gd_dzBis = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);

        gd_dzBis.widthHint = 120;
        _dzBis.setLayoutData(gd_dzBis);
        _toolkit.adapt(_dzBis);
        _toolkit.paintBordersFor(_dzBis);
        _dzBis.hinzufuegenSelektionsZuhoerer(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                _guiVew.dzDatumSelektiert();
            }
        });

        //
        _toolkit.createLabel(compAggr, "Parameter:", SWT.NONE);

        Composite compParameter = _toolkit.createComposite(compAggr, SWT.NONE);

        compParameter.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
        _toolkit.paintBordersFor(compParameter);
        compParameter.setLayout(new GridLayout(1, false));
        _cbtnDtvTag     = _toolkit.createButton(compParameter, "DTV-Tag", SWT.CHECK);
        _cbtnDtvMonat   = _toolkit.createButton(compParameter, "DTV-Monat", SWT.CHECK);
        _cbtnDtvQuartal = _toolkit.createButton(compParameter, "DTV-Quartal", SWT.CHECK);
        _cbtnDtvJahr    = _toolkit.createButton(compParameter, "DTV-Jahr", SWT.CHECK);
        _cbtnMsvJahr    = _toolkit.createButton(compParameter, "MSV-Jahr", SWT.CHECK);

        //
        _toolkit.createLabel(compAggr, "Langzeitz\u00E4hlstellenauswahl:", SWT.NONE);

        Composite compZaehlstellenAuswahl = _toolkit.createComposite(compAggr, SWT.NONE);

        compZaehlstellenAuswahl.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
        _toolkit.paintBordersFor(compZaehlstellenAuswahl);
        compZaehlstellenAuswahl.setLayout(new GridLayout(3, false));

        Button btnZaehlstellenAuswahl = _toolkit.createButton(compZaehlstellenAuswahl, "Langzeitz\u00E4hlstellenauswahl...", SWT.NONE);

        btnZaehlstellenAuswahl.setSize(66, 25);

        Button btnZaehlstellenAuswahlAlle = _toolkit.createButton(compZaehlstellenAuswahl, "Alle ausw\u00E4hlen", SWT.NONE);

        _lbZaehlstellenAnzahl = _toolkit.createLabel(compZaehlstellenAuswahl, "Es sind keine Z\u00E4hlstellen selektiert.", SWT.NONE);
        _lbZaehlstellenAnzahl.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        btnZaehlstellenAuswahlAlle.addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                _guiVew.btnZaehlstellenAuswahlAlleSelektiert();
            }
        });
        btnZaehlstellenAuswahl.addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                _guiVew.btnZaehlstellenAuswahlSelektiert();
            }
        });
        _cbtnMsvJahr.addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                _guiVew.cbtnAggrParSelektiert();
            }
        });
        _cbtnDtvJahr.addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                _guiVew.cbtnAggrParSelektiert();
            }
        });
        _cbtnDtvQuartal.addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                _guiVew.cbtnAggrParSelektiert();
            }
        });
        _cbtnDtvMonat.addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                _guiVew.cbtnAggrParSelektiert();
            }
        });
        _cbtnDtvTag.addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                _guiVew.cbtnAggrParSelektiert();
            }
        });

        //
        _sectionSteuerung.setExpanded(true);

        Group grpFortschritt = new Group(scrolledForm.getBody(), SWT.NONE);

        grpFortschritt.setText("Fortschrittanzeige");
        grpFortschritt.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        _toolkit.adapt(grpFortschritt);
        _toolkit.paintBordersFor(grpFortschritt);
        grpFortschritt.setLayout(new GridLayout(1, false));
        _prgFortschrittsanzeige = new ProgressBar(grpFortschritt, SWT.NONE);
        _prgFortschrittsanzeige.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        _toolkit.adapt(_prgFortschrittsanzeige, true, true);

        Group grpMeldungen = new Group(scrolledForm.getBody(), SWT.NONE);

        grpMeldungen.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
        grpMeldungen.setText("Meldungen");
        _toolkit.adapt(grpMeldungen);
        _toolkit.paintBordersFor(grpMeldungen);
        grpMeldungen.setLayout(new GridLayout(1, false));
        _txtMeldungen = new Text(grpMeldungen, SWT.WRAP | SWT.H_SCROLL | SWT.V_SCROLL | SWT.CANCEL | SWT.MULTI);
        _txtMeldungen.setEditable(false);
        _txtMeldungen.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
        _toolkit.adapt(_txtMeldungen, true, true);

        Composite compButtons = _toolkit.createComposite(scrolledForm.getBody(), SWT.NONE);

        compButtons.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
        _toolkit.paintBordersFor(compButtons);
        compButtons.setLayout(new GridLayout(2, true));
        _btnSenden = _toolkit.createButton(compButtons, "Auftr\u00E4ge senden", SWT.NONE);
        _btnSenden.setToolTipText("Aggregationsauftrge in die Auftragsliste eintragen");
        _btnSenden.addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                _guiVew.btnAggregationSelektiert();
            }
        });
        _btnSenden.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
        _btnSchliessen = _toolkit.createButton(compButtons, "Sicht schlie\u00DFen", SWT.NONE);
        _btnSchliessen.setToolTipText("Die aktuelle Sicht schlieen");
        _btnSchliessen.addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {
                _guiVew.btnSchliessenSelektiert();
            }
        });
        _btnSchliessen.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));

        //
        scompAll.setContent(compAll);
        scompAll.setMinSize(compAll.computeSize(SWT.DEFAULT, SWT.DEFAULT));
    }

    //~ GET METHODEN ==========================================================

    @Override
    public boolean isRequestSupported(SystemObject object, DataDescription dataDescription) {
        return false;
    }

    //~ METHODEN ==============================================================

    @Override
    public void update(ResultData[] results) {
        _guiVew.update(results);
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 22.10.13
