/*
 * @(#)PufferabrufGUIVew.java   06.09.12
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.lzzs.pufferabruf;

//~ NICHT JDK IMPORTE =========================================================

import de.bsvrz.dav.daf.main.archive.ArchiveData;
import de.bsvrz.dav.daf.main.archive.ArchiveDataKind;
import de.bsvrz.dav.daf.main.archive.ArchiveDataKindCombination;
import de.bsvrz.dav.daf.main.archive.ArchiveDataQueryResult;
import de.bsvrz.dav.daf.main.archive.ArchiveDataSpecification;
import de.bsvrz.dav.daf.main.archive.ArchiveDataStream;
import de.bsvrz.dav.daf.main.archive.ArchiveOrder;
import de.bsvrz.dav.daf.main.archive.ArchiveQueryPriority;
import de.bsvrz.dav.daf.main.archive.ArchiveRequestOption;
import de.bsvrz.dav.daf.main.archive.ArchiveTimeSpecification;
import de.bsvrz.dav.daf.main.archive.TimingType;
import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.ClientSenderInterface;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dav.daf.main.config.SystemObjectType;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.DataState;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.SenderRole;

import de.inovat.buv.gtm.datvew.lib.BaumVerwaltung;
import de.inovat.buv.gtm.datvew.lib.DatenVew;
import de.inovat.buv.gtm.datvew.lib.Fahrbahnen;
import de.inovat.buv.gtm.datvew.lib.SelektionVew;
import de.inovat.buv.gtm.datvew.lib.ZaehlStelle;
import de.inovat.buv.gtm.datvew.tls.De;
import de.inovat.buv.gtm.datvew.tls.Eak;
import de.inovat.buv.gtm.datvew.tls.Geraet;
import de.inovat.buv.inovat.lib.debug.Log;
import de.inovat.buv.inovat.lib.funktionen.datum.DatumFunktionen;
import de.inovat.buv.plugin.gtm.lzzs.Activator;
import de.inovat.buv.plugin.gtm.navigation.lib.AuswahlDialogGUI.ZS_MODUS;
import de.inovat.buv.plugin.gtm.navigation.lib.LangzeitzaehlstellenAuswahlFunktionen;
import de.inovat.buv.projektlib.dav.DavArchivVew;
import de.inovat.buv.projektlib.dav.DavDatenVew;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ITableColorProvider;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.ui.PlatformUI;

import static de.inovat.buv.inovat.lib.konstanten.Konstanten.NEWLINE;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_GRUEN_PALE;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_ROT_HELL;

//~ JDK IMPORTE ===============================================================

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

//~ KLASSEN ===================================================================

/**
 * Klasse verwaltet das GUI "Pufferabruf".
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 225 $ / $Date: 2012-10-18 12:55:33 +0200 (Do, 18 Okt 2012) $ / ($Author: LG $)
 */
public class PufferabrufGUIVew implements ClientSenderInterface {

    /**
     * Konstante die fr die Anzahl der Pufferabrufinhalte zu einem Zeitpunkt abgerufen werden.
     */
    private static final String   ANZAHL_ABRUF_PUFFERINHALT = "1";
    private static final String[] AR_SPALTEN_NAMEN          = { "Pufferanfrage", "Datum", "DZ", "FS", "Objekt",                          //
                                                                "00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11",  //
                                                                "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23" };
    private static final int      AR_STUNDEN_INDEX_ANFANG   = 5;
    private static final int      AR_STUNDEN_LAENGE         = 24;
    private static final String   ASP_ANFRAGE               = "asp.anfrage";
    private static final String   ASP_TLS_ABRUF             = "asp.tlsAbruf";
    private static final String   ASP_TLS_ANFRAGE           = "asp.tlsAntwort";
    private static final String   ATG_ACHSLASTMESSSTELLE    = "atg.achsLastMessStelle";
    private static final String   ATG_ARCHIV_ANFRAGE_AXL    = "atg.tlsAxlErgebnisMeldungAchsLastDatenVersion11";
    private static final String   ATG_ARCHIV_ANFRAGE_LVE    = "atg.tlsLveErgebnisMeldungVersion24";
    private static final String   ATG_DE                    = "atg.de";
    private static final String   ATG_PUFFER_ABRUF_AXL      = "atg.aggrAxlSteuerung";
    private static final String   ATG_PUFFER_ABRUF_LVE      = "atg.tlsLveAbrufPufferInhalt";
    private static final String   SO_AGGR_AXL               = "aggrAxl.vewStandard1";
    private static final int      SPALTENBREITE             = 100;
    private static final int      SPALTENBREITE_STATUS      = 30;
    private static final String   TYP_ACHSLASTMESSSTELLE    = "typ.achsLastMessStelle";
    private static final String   TYP_AXL                   = "typ.deAxl";
    private static final String   TYP_LVE                   = "typ.deLve";

    //~ FELDER ================================================================

    /** Die Liste enthlt Zeilen aus der Tabelle, die ausgewhlt sind. */
    private ArrayList<Integer> _listeAusgewaehlterZeilen = new ArrayList<Integer>();

    /**
     * Map enthlt fr eine Fahrstreifen die entsprechende AchsLastMessStellenQuelle.
     * Key und Value sind als SystemObjekz-Pid gespeichert.
     */
    private Map<String, String> _mapFsDeAxl = new HashMap<String, String>();

    /** Gefilterter Inhalt der Tabelle. */
    private List<PufferabrufObjekt> _listePufferabrufObjekteGefiltert = new ArrayList<PufferabrufObjekt>();

    /** Die selektierten Langzeitzaehlstellen. */
    private List<ZaehlStelle> _listeLzz = new ArrayList<ZaehlStelle>();

    /** Stellt fest, ob die Tabelle gefiltert wurde. */
    private boolean            _istFilter = false;
    private AttributeGroup     _atgPufferAbruf;
    private DataDescription    _dataDescriptionArchivAnfrage;
    private DataDescription    _dataDescriptionPufferAbruf;
    private ClientDavInterface _dav;
    private DataModel          _davKonf;
    private PufferabrufGUI     _gui;

    /** Nicht gefilterter Inhalt der Tabelle. */
    private List<PufferabrufObjekt> _listePufferabrufObjekte;
    private boolean                 _sendeStatus;
    private SystemObject            _sendeStatusSo;
    private SystemObject            _soAggrAxlVew;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Erzeugt eine Instanz der Klasse PufferabrufGUIVew.
     *
     * @param gui GUI-Instanz.
     */
    public PufferabrufGUIVew(PufferabrufGUI gui) {

        // -------------------------------------------------------------------
        _gui = gui;

        // -------------------------------------------------------------------
        _davKonf = DavDatenVew.getInstanz().getDav().getDataModel();
        _dav     = DavDatenVew.getInstanz().getDav();

        // -------------------------------------------------------------------
        // Initialisiere Dav-Daten:
        // ArchivAnfrage:
        Aspect         aspTlsAntwort = _davKonf.getAspect(ASP_TLS_ANFRAGE);
        AttributeGroup atg;

        if (_gui.getModus() == ZS_MODUS.LZZ) {
            atg = _davKonf.getAttributeGroup(ATG_ARCHIV_ANFRAGE_LVE);
        } else {
            atg = _davKonf.getAttributeGroup(ATG_ARCHIV_ANFRAGE_AXL);
        }

        _dataDescriptionArchivAnfrage = new DataDescription(atg, aspTlsAntwort);

        // PufferAbruf:
        Aspect aspPufferAbruf;

        if (_gui.getModus() == ZS_MODUS.LZZ) {
            aspPufferAbruf  = _dav.getDataModel().getAspect(ASP_TLS_ABRUF);
            _atgPufferAbruf = _dav.getDataModel().getAttributeGroup(ATG_PUFFER_ABRUF_LVE);
        } else {
            aspPufferAbruf  = _dav.getDataModel().getAspect(ASP_ANFRAGE);
            _atgPufferAbruf = _dav.getDataModel().getAttributeGroup(ATG_PUFFER_ABRUF_AXL);
        }

        _dataDescriptionPufferAbruf = new DataDescription(_atgPufferAbruf, aspPufferAbruf);

        //
        _soAggrAxlVew = _dav.getDataModel().getObject(SO_AGGR_AXL);

        // -------------------------------------------------------------------
        // Ermittle DE-Axl-Objekte:
        if (_gui.getModus() == ZS_MODUS.AXL) {

            // Ermittle Liste aller existierender Achslastmessstellen:
            List<SystemObject> listeAchs;

            try {
                listeAchs = _davKonf.getType(TYP_ACHSLASTMESSSTELLE).getElements();
            }
            catch (Exception ignored) {
                listeAchs = new ArrayList<SystemObject>();
            }

            //
            if (listeAchs != null) {
                AttributeGroup   atgAxlLastMessStelle = _davKonf.getAttributeGroup(ATG_ACHSLASTMESSSTELLE);
                Data[]           dataArray            = _davKonf.getConfigurationData(listeAchs, atgAxlLastMessStelle);
                SystemObjectType typeDeAxl            = _davKonf.getType(TYP_AXL);

                for (Data oData : dataArray) {
                    SystemObject soAxlQuelle = oData.getReferenceValue("AchsLastMessStellenQuelle").getSystemObject();

                    if ((soAxlQuelle != null) && (soAxlQuelle.isOfType(typeDeAxl))) {
                        SystemObject soFS = oData.getReferenceValue("FahrStreifen").getSystemObject();

                        _mapFsDeAxl.put(soFS.getPidOrNameOrId(), soAxlQuelle.getPidOrNameOrId());
                    }
                }
            }
        }
    }

    //~ AUFZAEHLUNGSTYPEN =====================================================

    /**
     * Status der Archiv-Anfrage.
     */
    private enum Status {
        FEHLER("F", FARBE_ROT_HELL), OK("ok", FARBE_GRUEN_PALE);

        Color  _farbe;
        String _status;

        //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==========

        private Status(String status, Color farbe) {
            _status = status;
            _farbe  = farbe;
        }
    }

    //~ METHODEN ==============================================================

    /**
     * Archivanfrage fr alle PufferabrufObjekte.
     */
    private void archivAnfragePufferAbruf() {
        long tagStart;
        long tagEnde;

        for (PufferabrufObjekt po : _listePufferabrufObjekte) {

            //
            if (!_dav.getArchive().isArchiveAvailable()) {
                Shell shell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();

                MessageDialog.openError(shell, "Fehler", "Das Archiv ist zur Zeit nicht verfgbar!");

                break;
            }

            //
            tagStart = po._datum;
            tagEnde  = DatumFunktionen.setzeZeit(tagStart, 23, 0);

            //
            ArchiveTimeSpecification   archiveTimeSpecification   = new ArchiveTimeSpecification(TimingType.DATA_TIME, false, tagStart, tagEnde);
            ArchiveDataKindCombination archiveDataKindCombination = new ArchiveDataKindCombination(ArchiveDataKind.ONLINE);
            ArchiveDataSpecification   archiveDataSpecification   = new ArchiveDataSpecification(  //
                archiveTimeSpecification, archiveDataKindCombination, ArchiveOrder.BY_INDEX,       //
                ArchiveRequestOption.NORMAL, _dataDescriptionArchivAnfrage, po._de.getSystemObjekt());

            try {
                ArchiveDataQueryResult queryResult = _dav.getArchive().request(ArchiveQueryPriority.MEDIUM, archiveDataSpecification);

                if (queryResult.isRequestSuccessful()) {
                    ArchiveDataStream[] archiveDataStream = queryResult.getStreams();

                    for (ArchiveDataStream data : archiveDataStream) {
                        ArchiveData archivDaten = data.take();

                        while ((archivDaten != null)) {
                            if ((archivDaten.getData() != null) && (archivDaten.getDataType().equals(DataState.DATA))) {

                                // Folgende einzelabfragen basieren auf einem Archivzustand (bug), das auch Daten zurck liefert,
                                // die nicht innerhalb des angefraten Archivzeitraumes liegen.
                                if (DatumFunktionen.getDatumMitInitZeit(tagStart) == DatumFunktionen.getDatumMitInitZeit(archivDaten.getDataTime())) {

                                    // TODO Frage: vergleiche nur Stunden (also Minuten mssen  nicht unbedingt 00 sein, wir das frher war)?
                                    int stunde = DatumFunktionen.getStunden(archivDaten.getDataTime());

                                    po._arStundenStatus[stunde] = Status.OK;
                                }
                            }

                            archivDaten = data.take();
                        }
                    }
                }
            }
            catch (Exception e) {
                MessageDialog.openError(_gui.getShell(), "Fehler", "Es sind Probleme bei der Archivanfrage aufgetreten.");
            }
        }
    }

    /**
     * Button 'Filter Alle' wird selektiert.
     */
    protected void btnFilterAlleSelektiert() {

        // Lsche die Selektion und Input der Tabelle:
        loescheSelektion();
        _listePufferabrufObjekteGefiltert = new ArrayList<PufferabrufObjekt>();

        // Setze neue Input der Tabelle:
        _gui.getTableViewer().setInput(_listePufferabrufObjekte);

        // Schalte den Filter aus:
        _istFilter = false;
    }

    /**
     * Button 'Filter Fehlende' wird selektiert.
     */
    protected void btnFilterFehlendeSelektiert() {

        // Lsche die Selektion und Input der Tabelle:
        loescheSelektion();

        // Erstelle und setze neue Input der Tabelle:
        _listePufferabrufObjekteGefiltert = new ArrayList<PufferabrufObjekt>();

        for (PufferabrufObjekt po : _listePufferabrufObjekte) {
            if (istPufferObjektMitFehler(po)) {
                _listePufferabrufObjekteGefiltert.add(po);
            }
        }

        _gui.getTableViewer().setInput(_listePufferabrufObjekteGefiltert);

        // Schalte den Filter ein:
        _istFilter = true;
    }

    /**
     * Button 'Filter Selektierte' wird selektiert.
     */
    protected void btnFilterSelektierteSelektiert() {

        // Lsche Input der Tabelle:
        // Erstelle und setze neue Input der Tabelle:
        List<PufferabrufObjekt> listeSelektiert = new ArrayList<PufferabrufObjekt>();

        for (int i : _listeAusgewaehlterZeilen) {
            if (_istFilter) {
                listeSelektiert.add(_listePufferabrufObjekteGefiltert.get(i));
            } else {
                listeSelektiert.add(_listePufferabrufObjekte.get(i));
            }
        }

        _listePufferabrufObjekteGefiltert = new ArrayList<PufferabrufObjekt>();
        _listePufferabrufObjekteGefiltert.addAll(listeSelektiert);
        _gui.getTableViewer().setInput(_listePufferabrufObjekteGefiltert);

        // Selektiere alle:
        _listeAusgewaehlterZeilen = new ArrayList<Integer>();
        btnSelektionAlleSelektiert();

        // Schalte den Filter ein:
        _istFilter = true;
    }

    /**
     * Die Taste "LangzeitzaehlstellenAuswahl"  wird selektiert.
     * <p>
     * Die Menge der selektierten Langzeitzaehlstellen wird gesetzt.
     * </p>
     */
    protected void btnLangzeitzaehlstellenAuswahlSelektiert() {

        // ffne den LangzeitzaehlstellenAuswahlDialog mit der Vorselektion:
        ZS_MODUS modus = _gui.getModus();

        if (modus == ZS_MODUS.LZZ) {
            modus = null;
        }

        _listeLzz = LangzeitzaehlstellenAuswahlFunktionen.langzeitZaehlstellenAuswahlDialogOeffnen(_gui.getShell(), _listeLzz, modus);

        // Zeige im GUI, wie viel Langzeitzaehlstellen sind selektiert:
        zeigeAnzahlSelLangzeitzaehlstellen();
    }

    /**
     * Die Schaltflche "ManuellePufferanfrage"  wird selektiert.
     *
     * Pufferanfrage wird fr die selektierten Zeilen gestartet.
     */
    protected void btnManuellePufferanfrageSelektiert() {
        StringBuilder fehler = new StringBuilder();

        // ------------------------------------------------------------
        // Ermittle Liste mit dem Inhalt der Tabelle:
        List<PufferabrufObjekt> listePo;

        if (_istFilter) {
            listePo = _listePufferabrufObjekteGefiltert;
        } else {
            listePo = _listePufferabrufObjekte;
        }

        // ------------------------------------------------------------
        // Betrachte alle in der Tabelle selektierte Objekte:
        PufferabrufObjekt po;
        SystemObject      soDavAnmeldung;

        // Menge enthlt die SystemObjekte und Datum fr die Pufferanfrage
        // um Wiederholungen zu vermeiden:
        Set<String> mengeSoDatum = new HashSet<String>();

        for (int indexSelektiert : _listeAusgewaehlterZeilen) {
            po = listePo.get(indexSelektiert);

            // ------------------------------------------------------------
            // Ermittle SystemObject fr die DaV-Anmeldung der Pufferanfragedaten:
            soDavAnmeldung = null;

            if (_gui.getModus() == ZS_MODUS.LZZ) {

                // Fr DE des PufferabrufObjekts suche bergeordnetes SM.
                // Fr gefundenes SM suche De von gleichem Typ, wie DE des PufferabrufObjekts und
                // mit dem DEKanal 255.
                SystemObjectType typDe      = po._de.getSystemObjekt().getType();
                Geraet           sm         = po._de.getUeberGeordnetesEak().getUeberGeordnetesGeraet();
                Object[]         arSmKinder = sm.ermittleKinder();

                for (int i = arSmKinder.length - 1; i >= 0; i--) {
                    Object kind = arSmKinder[i];

                    if (kind instanceof Eak) {
                        Eak eak = (Eak) kind;

                        for (De de : eak.getListeDe()) {
                            int deKanal = de.getSystemObjekt().getConfigurationData(_davKonf.getAttributeGroup(ATG_DE)).getScaledValue("DEKanal").intValue();

                            if ((deKanal == 255) && (de.getSystemObjekt().isOfType(typDe))) {
                                soDavAnmeldung = de.getSystemObjekt();

                                break;
                            }
                        }

                        if (soDavAnmeldung != null) {
                            break;
                        }
                    }
                }
            } else {
                soDavAnmeldung = _soAggrAxlVew;
            }

            // ------------------------------------------------------------
            // Fehlermeldung:
            if (soDavAnmeldung == null) {
                fehler.append(String.format("%s  %s", DatumFunktionen.getDatumAlsString(po._datum), po._de.getSystemObjekt().getPidOrNameOrId()));
                fehler.append(NEWLINE);
                Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, String.format(  //
                    "Systemobjekt fr die DaV-Anmeldung der Pufferanfragedaten <%s> kann nicht ermittelt werden.", po._de.getSystemObjekt().getPidOrNameOrId())));
            }

            // ------------------------------------------------------------
            // Starte die Pufferanfrage.
            // Pufferanfrage wird gestartet, nur falls noch nicht mit gleichen Bedienungen durchgefhrt wurde:
            else if (mengeSoDatum.add(String.format("%s#%d", soDavAnmeldung.getPid(), po._datum))) {
                if (!starteManuellePufferanfrage(po, soDavAnmeldung)) {

                    // Fehlermeldung:
                    fehler.append(String.format("%s  <%s>", DatumFunktionen.getDatumAlsString(po._datum), soDavAnmeldung.getPidOrNameOrId()));
                    fehler.append(NEWLINE);
                }
            }
        }

        // ------------------------------------------------------------
        // Fehlermeldung:
        if (fehler.length() > 0) {
            fehler.insert(0, NEWLINE);
            fehler.insert(0, NEWLINE);
            fehler.insert(0, "Folgende Pufferanfragen wurden nicht durchgefhrt:");
            fehler.append(NEWLINE);
            fehler.append(NEWLINE);
            fehler.append("(s. Meldungen im ErrorLog)");
            MessageDialog.openError(_gui.getShell(), "Fehler", fehler.toString());
        }
    }

    /**
     * Button 'Selektion Alle' wird selektiert.
     */
    protected void btnSelektionAlleSelektiert() {
        for (TableItem zeile : _gui.getTableViewer().getTable().getItems()) {
            zeile.setChecked(true);
        }

        cbtnPufferanfrageSelektiert();
    }

    /**
     * Button 'Selektion Fehlende' wird selektiert.
     */
    protected void btnSelektionFehlendeSelektiert() {
        boolean                 istFehler;
        List<PufferabrufObjekt> listePo;

        if (_istFilter) {
            listePo = _listePufferabrufObjekteGefiltert;
        } else {
            listePo = _listePufferabrufObjekte;
        }

        for (int i = 0; i < listePo.size(); i++) {
            istFehler = istPufferObjektMitFehler(listePo.get(i));
            _gui.getTableViewer().getTable().getItem(i).setChecked(istFehler);
        }

        cbtnPufferanfrageSelektiert();
    }

    /**
     * Button 'Selektion Keine' wird selektiert.
     */
    protected void btnSelektionKeineSelektiert() {
        for (TableItem zeile : _gui.getTableViewer().getTable().getItems()) {
            zeile.setChecked(false);
        }

        cbtnPufferanfrageSelektiert();
    }

    /**
     * Die Schaltflche "Tabelle neu laden"  wird selektiert.
     * </p>
     * Tabelle wird neu geladen.
     */
    protected void btnTabelleNeuLadenSelektiert() {

        // ----------------------------------------------
        // Prfe den Zeitbereich:
        long von = _gui.getDatumVon().getDatum().getTime();

        von = DatumFunktionen.getDatumMitInitZeit(von);

        long bis = _gui.getDatumBis().getDatum().getTime();

        bis = DatumFunktionen.getDatumMitInitZeit(bis);

        if (von > bis) {
            MessageDialog.openError(_gui.getShell(), "Fehler",  //
                                    "Anfang des Zeitbereichs ist grer als das Ende. Bitte korrigieren sie zuerst die Zeitbereichsangabe!");

            return;
        }

        // ----------------------------------------------
        // Flle die Tabelle:
        fuelleTabelle(von, bis);

        // ----------------------------------------------
        setzeEnabledWerteFuerButtons();

        // ----------------------------------------------
        btnFilterAlleSelektiert();
        btnSelektionKeineSelektiert();
    }

    /**
     * Check-Button 'Pufferanfrage' aus der Tabelle wird selektiert.
     */
    private void cbtnPufferanfrageSelektiert() {
        _listeAusgewaehlterZeilen = new ArrayList<Integer>();

        int i = 0;

        for (TableItem zeile : _gui.getTableViewer().getTable().getItems()) {
            if (zeile.getChecked()) {
                _listeAusgewaehlterZeilen.add(i);
            }

            i++;
        }

        _gui.getBtnPufferanfrage().setEnabled(!_listeAusgewaehlterZeilen.isEmpty());
    }

    @Override
    public void dataRequest(SystemObject so, DataDescription dataDescription, byte status) {
        _sendeStatusSo = so;
        _sendeStatus   = (status == START_SENDING);
    }

    /**
     * Erstelle den Inhalt der Tabelle und flle die.
     *
     * @param von Von Datum.
     * @param bis Bis Datum.
     */
    private void fuelleTabelle(long von, long bis) {
        _listePufferabrufObjekte = new ArrayList<PufferabrufObjekt>();

        List<Fahrbahnen> listeFsOhneQuelle = new ArrayList<Fahrbahnen>();

        // -----------------------------------------------
        // Erstelle die Input-Liste:
        // -----------------------------------------------
        // Fr jede selektierte ZaehlStelle:
        for (ZaehlStelle zs : _listeLzz) {

            // -----------------------------------------------
            // Ermittle alle FS:
            List<Fahrbahnen> listeFs = new ArrayList<Fahrbahnen>();

            for (Fahrbahnen fs : zs.ermittleArFsInRichtung()) {
                listeFs.add(fs);
            }

            for (Fahrbahnen fs : zs.ermittleArFsGegenRichtung()) {
                listeFs.add(fs);
            }

            // -----------------------------------------------
            // Fr jede Fahrbahn:
            De     de;
            String quelle;

            for (Fahrbahnen fs : listeFs) {

                // -----------------------------------------------
                // Ermittle die FS-Quelle (De):
                if (_gui.getModus() == ZS_MODUS.LZZ) {
                    quelle = fs.getFsQuellePid();
                } else {
                    quelle = _mapFsDeAxl.get(fs.getSystemObjekt().getPidOrNameOrId());
                }

                if (quelle == null) {
                    de = null;
                } else {
                    de = DatenVew.getInstanz().ermittleDe(quelle);
                }

                if (de == null) {
                    listeFsOhneQuelle.add(fs);
                } else {

                    // -----------------------------------------------
                    // Fr jeden Tag des gewhlten Bereichs:
                    long tagStart = von;

                    while (tagStart <= bis) {

                        // Fge ein PufferabrufObjekt ein:
                        _listePufferabrufObjekte.add(new PufferabrufObjekt(zs, fs, de, tagStart));

                        // Nchsten Tag:
                        tagStart = DatumFunktionen.getNaechstenTag(tagStart);
                    }
                }
            }
        }

        // Fehlermeldung:
        if (!listeFsOhneQuelle.isEmpty()) {
            StringBuilder text = new StringBuilder("Es wurde keine Quelle fr die folgenden Fahrstreifen gefunden:");

            text.append(NEWLINE).append(NEWLINE);

            for (Fahrbahnen fs : listeFsOhneQuelle) {
                text.append(fs.getSystemObjekt().getPidOrNameOrId()).append("; ");
            }

            text.deleteCharAt(text.length() - 1);
            text.deleteCharAt(text.length() - 1);
            text.append("!");
            MessageDialog.openError(_gui.getShell(), "Fehler", text.toString());
        }

        // -----------------------------------------------
        // Sortiere die Liste:
        // -----------------------------------------------
        Collections.sort(_listePufferabrufObjekte, new Comparator<PufferabrufObjekt>() {
            @Override
            public int compare(PufferabrufObjekt po1, PufferabrufObjekt po2) {

                // Sortierung nach Datum, DZ (Zhlstellen), FS (Fahrstreifen):
                // Datum:
                Long d1 = po1._datum;
                Long d2 = po2._datum;

                if (d1.equals(d2)) {

                    // DZ:
                    String dz1 = po1._zs.getSystemObjekt().getNameOrPidOrId();
                    String dz2 = po2._zs.getSystemObjekt().getNameOrPidOrId();

                    if (dz1.equals(dz2)) {

                        // FS:
                        String f1 = po1._fs.getSystemObjekt().getNameOrPidOrId();
                        String f2 = po2._fs.getSystemObjekt().getNameOrPidOrId();

                        return f1.compareTo(f2);
                    } else {
                        return dz1.compareTo(dz2);
                    }
                } else {
                    return d1.compareTo(d2);
                }
            }
        });

        // -----------------------------------------------
        // Archivanfrage:
        // -----------------------------------------------
        archivAnfragePufferAbruf();

        // -----------------------------------------------
        // Setze TabellenInput:
        // -----------------------------------------------
        Display.getDefault().syncExec(new Runnable() {
            @Override
            public void run() {
                _gui.getTableViewer().setInput(_listePufferabrufObjekte);
            }
        });
    }

    /**
     * Initialisiere das GUI.
     */
    protected void initGui() {

        // -------------------------------------------------
        // Flle die GUI-Textfelde Typ, Atg und Aspekt je nach Modus.
        // Beim Modus 0 handelt es sich um eine Pufferabfrage der FG1 Typ 79 (d.h. Typ deLve),
        // beim Modus 1 handelt es sich um eine Pufferanfrage der FG2 Typ 62 (d.h. Typ deAxl).
        if (_gui.getModus() == ZS_MODUS.LZZ) {
            _gui.getTxtTyp().setText(TYP_LVE);
            _gui.getTxtAtg().setText(ATG_ARCHIV_ANFRAGE_LVE);
        } else {
            _gui.getTxtTyp().setText(TYP_AXL);
            _gui.getTxtAtg().setText(ATG_ARCHIV_ANFRAGE_AXL);
        }

        _gui.getTxtAsp().setText(ASP_TLS_ANFRAGE);

        // -------------------------------------------------
        // Inititialisiere die Liste der Langzeitzaehlstellen mit den
        // im Baum selektierten Langzeitzaehlstellen.
        if (_listeLzz.size() == 0) {
            List<ZaehlStelle> alleAusgewaehltenZaehlStellen = SelektionVew.getInstanz().ermittleListeSelektierterZaehlStellen();

            if (_gui.getModus() == ZS_MODUS.LZZ) {
                _listeLzz.addAll(alleAusgewaehltenZaehlStellen);
            } else {
                List<ZaehlStelle> listeAchslastzaehlstellen = BaumVerwaltung.getInstanz().getAchslastZaehlStellen();

                for (ZaehlStelle axl : alleAusgewaehltenZaehlStellen) {
                    if (listeAchslastzaehlstellen.contains(axl)) {
                        _listeLzz.add(axl);
                    }
                }
            }
        }

        zeigeAnzahlSelLangzeitzaehlstellen();

        // -------------------------------------------------
        // Initialisiere Tabelle:
        Table table = _gui.getTableViewer().getTable();

        for (int i = 0; i < AR_SPALTEN_NAMEN.length; i++) {
            TableColumn tabcol = new TableColumn(table, SWT.NONE, i);

            tabcol.setText(AR_SPALTEN_NAMEN[i]);

            if ((i > 0) && (i < AR_STUNDEN_INDEX_ANFANG)) {
                tabcol.setWidth(SPALTENBREITE);
            } else {
                tabcol.setWidth(SPALTENBREITE_STATUS);
            }
        }

        // Texte in Spalten links positionieren:
        for (int i = 2; i < 5; i++) {
            table.getColumn(i).setAlignment(SWT.LEFT);
        }

        //
        _gui.getTableViewer().setContentProvider(new ArrayContentProvider());
        _gui.getTableViewer().setLabelProvider(new TableLabelProvider());

        // SelectionListener fr die Checkboxen:
        _gui.getTableViewer().refresh();
        _gui.getTableViewer().getTable().addSelectionListener(new SelectionListener() {
            @Override
            public void widgetDefaultSelected(SelectionEvent e) {}
            @Override
            public void widgetSelected(SelectionEvent e) {
                cbtnPufferanfrageSelektiert();
            }
        });
    }

    //~ GET METHODEN ==========================================================

    @Override
    public boolean isRequestSupported(SystemObject arg0, DataDescription arg1) {
        return true;
    }

    //~ METHODEN ==============================================================

    /**
     * Stellt fest, ob das PufferObjekt mit Fehler ist.
     *
     * @param po PufferObjekt.
     *
     * @return true, falls das PufferObjekt mit Fehler ist,
     * false - sonst.
     */
    private boolean istPufferObjektMitFehler(PufferabrufObjekt po) {
        boolean istFehler = false;

        for (Status st : po._arStundenStatus) {
            if (st == Status.FEHLER) {
                istFehler = true;

                break;
            }
        }

        return istFehler;
    }

    /**
     * Stellt fest, ob das SendenErlaubnis fr SystemObject vorhanden ist.
     *
     * @param so SystemObject.
     *
     * @return true, falls SendenErlaubnis fr SystemObject vorhanden ist,
     * false - sonst.
     */
    private boolean istSendenErlaubt(SystemObject so) {
        if (_gui.getModus() == ZS_MODUS.LZZ) {
            return _sendeStatus && (so.equals(_sendeStatusSo));
        } else {
            return _sendeStatus;
        }
    }

    /**
     * Lsche die Selektion in der Tabelle
     */
    private void loescheSelektion() {
        _listeAusgewaehlterZeilen = new ArrayList<Integer>();

        for (TableItem zeile : _gui.getTableViewer().getTable().getItems()) {
            zeile.setChecked(false);
        }

        //
        _gui.getBtnPufferanfrage().setEnabled(!_listeAusgewaehlterZeilen.isEmpty());
    }

    /**
     * Setze EnabledWerte fr die Buttons 'Steuerung der Pufferanfrage'.
     */
    private void setzeEnabledWerteFuerButtons() {
        boolean wert = !_listePufferabrufObjekte.isEmpty();

        _gui.getBtnSelektionAlle().setEnabled(wert);
        _gui.getBtnSelektionFehlende().setEnabled(wert);
        _gui.getBtnSelektionKeine().setEnabled(wert);
        _gui.getBtnFilterAlle().setEnabled(wert);
        _gui.getBtnFilterFehlende().setEnabled(wert);
        _gui.getBtnFilterSelektierte().setEnabled(wert);
    }

    /**
     * Starte die manuelle Pufferanfrage.
     *
     * @param po PufferabrufObjekt.
     * @param soDavAnmeldung SystemObject.
     *
     * @return true, falls Pufferanfrage erfolgreich durchgefhrt wurde,
     * false - sonst.
     */
    private boolean starteManuellePufferanfrage(PufferabrufObjekt po, SystemObject soDavAnmeldung) {

        // ------------------------------------------------------------------
        // Anmeldung beim Datenverteiler zum Senden der Pufferanfragedaten:
        try {
            _dav.subscribeSender(this, soDavAnmeldung, _dataDescriptionPufferAbruf, SenderRole.sender());
        }
        catch (Exception e) {
            Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Fehler bei der Anmeldung beim Datenverteiler zum Senden der Pufferanfragedaten", e));

            return false;
        }

        // ------------------------------------------------------------------
        // Ein paar mal versuchen, ob Sendeerlaubnis bereits vorliegt...
        boolean erlaubt = false;

        for (int i = 1; i < 10; i++) {
            if (istSendenErlaubt(soDavAnmeldung)) {
                erlaubt = true;

                break;
            }

            try {
                Thread.sleep(500);
            }
            catch (Exception ignored) {}
        }

        // ------------------------------------------------------------------
        boolean istOk = true;

        // ------------------------------------------------------------------
        // Fehlermeldung:
        if (!erlaubt) {
            Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Sendeerlaubnis fr <" + soDavAnmeldung.getPidOrId() + "> ist nicht vorhanden."));
            istOk = false;
        } else

        // ------------------------------------------------------------------
        // Sende die Daten:
        {
            long zeitPunkt = po._datum;

            // Daten werden fr jede Stunde gesendet:
            for (int stunde = 0; stunde < 24; stunde++) {
                zeitPunkt = DatumFunktionen.setzeZeit(zeitPunkt, stunde, 0);

                if (po._arStundenStatus[stunde].equals(Status.FEHLER)) {

                    // Erstelle die DaV-Daten:
                    Data daten = _dav.createData(_atgPufferAbruf);

                    if (_gui.getModus() == ZS_MODUS.LZZ) {
                        Data.TimeValue timeValue = daten.getTimeValue("Zeitpunkt");

                        timeValue.setMillis(zeitPunkt);

                        Data.TextValue anzahl = daten.getTextValue("Anzahl");

                        anzahl.setText(ANZAHL_ABRUF_PUFFERINHALT);
                    }

                    //
                    else {
                        daten.getTimeValue("von").setMillis(zeitPunkt);
                        daten.getTimeValue("bis").setMillis(zeitPunkt);
                        daten.getArray("DeAxl").setLength(1);
                        daten.getArray("DeAxl").getItem(0).asReferenceValue().setSystemObject(po._de.getSystemObjekt());
                    }

                    // Sende die DaV-Daten:
                    ResultData datenPufferAnfrageLve = new ResultData(soDavAnmeldung, _dataDescriptionPufferAbruf, DatumFunktionen.getAktuelleDateTime(), daten);

                    try {
                        if (istSendenErlaubt(soDavAnmeldung)) {
                            _dav.sendData(datenPufferAnfrageLve);
                        }
                    }
                    catch (Exception e) {
                        Log.zeige(Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Fehler beim Senden der Pufferanfragedaten", e));
                        istOk = false;

                        break;
                    }
                }
            }
        }

        // ------------------------------------------------------------------
        // Abmeldung:
        _dav.unsubscribeSender(this, soDavAnmeldung, _dataDescriptionPufferAbruf);

        //
        _sendeStatus   = false;
        _sendeStatusSo = null;

        return istOk;
    }

    /**
     * Zeige im GUI, wie viele Langzeitzaehlstellen werden exportiert.
     */
    private void zeigeAnzahlSelLangzeitzaehlstellen() {
        String text;

        if (_listeLzz.size() == 0) {
            text = "Die Pufferabfrage wird nicht durchgefhrt (keine Langzeitzhlstelle ausgewhlt ist).";
        } else if (_listeLzz.size() == 1) {
            text = "Die Pufferabfrage wird fr eine Langzeitzhlstelle durchgefhrt.";
        } else {
            text = "Die Pufferabfrage wird fr  " + _listeLzz.size() + " Langzeitzaehlstellendaten durchgefhrt.";
        }

        _gui.getLbLangZeitZaehlStellenAuswahl().setText(text);
        _gui.getLbLangZeitZaehlStellenAuswahl().getParent().layout();

        // Funktion 'Tabelle neu laden' wird erlaubt, nur wenn mindestenz eine
        // Langzeitzaehlstelle selektiert ist:
        _gui.getBtnTablNeuLaden().setEnabled((_listeLzz.size() > 0) && (DavArchivVew.getInstanz().istArchivVerfuegbar()));
    }

    //~ INNERE KLASSEN ========================================================

    /**
     * Klasse beschreibt ein PufferabrufObjekt.
     * PufferabrufObjekt wird in einer Zeile der Tabelle dargestellt.
     *
     * @author inovat
     * @author Liliya Givorgizova (LG)
     * @version $Revision: 225 $ / $Date: 2012-10-18 12:55:33 +0200 (Do, 18 Okt 2012) $ / ($Author: LG $)
     */
    class PufferabrufObjekt {
        private Status[] _arStundenStatus;

        /** Datum, wobei Tag relevant ist. */
        private long        _datum;
        private De          _de;
        private Fahrbahnen  _fs;
        private ZaehlStelle _zs;

        //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==========

        /**
         * Erzeugt eine Instanz der Klasse PufferabrufObjekt.
         *
         * @param zs ZaehlStelle.
         * @param fs Fahrbahnen.
         * @param de DE.
         * @param datum Datum.
         */
        private PufferabrufObjekt(ZaehlStelle zs, Fahrbahnen fs, De de, long datum) {
            _zs    = zs;
            _fs    = fs;
            _de    = de;
            _datum = datum;

            //
            _arStundenStatus = new Status[AR_STUNDEN_LAENGE];

            for (int i = 0; i < AR_STUNDEN_LAENGE; i++) {
                _arStundenStatus[i] = Status.FEHLER;
            }
        }
    }


    /**
     * LabelProvider fr die Tabelle.
     */
    class TableLabelProvider implements ITableLabelProvider, ITableColorProvider {
        @Override
        public void addListener(ILabelProviderListener listener) {}

        @Override
        public void dispose() {}

        //~ GET METHODEN ======================================================

        @Override
        public Color getBackground(Object element, int columnIndex) {
            if (columnIndex >= AR_STUNDEN_INDEX_ANFANG) {
                if (element instanceof PufferabrufObjekt) {
                    PufferabrufObjekt po = (PufferabrufObjekt) element;

                    return po._arStundenStatus[columnIndex - AR_STUNDEN_INDEX_ANFANG]._farbe;
                }
            }

            return null;
        }

        @Override
        public Image getColumnImage(Object element, int columnIndex) {
            return null;
        }

        @Override
        public String getColumnText(Object element, int columnIndex) {
            if (element instanceof PufferabrufObjekt) {
                PufferabrufObjekt po = (PufferabrufObjekt) element;

                switch (columnIndex) {
                case 0 :
                    return "";

                case 1 :
                    return DatumFunktionen.getDatumAlsString(po._datum);

                case 2 :
                    return po._zs.getSystemObjekt().getNameOrPidOrId();

                case 3 :
                    return po._fs.getSystemObjekt().getNameOrPidOrId();

                case 4 :
                    return po._de.getSystemObjekt().getPidOrNameOrId();
                }

                if ((columnIndex >= AR_STUNDEN_INDEX_ANFANG) && (columnIndex < AR_STUNDEN_INDEX_ANFANG + AR_STUNDEN_LAENGE)) {
                    return po._arStundenStatus[columnIndex - AR_STUNDEN_INDEX_ANFANG]._status;
                }
            }

            return "???";
        }

        @Override
        public Color getForeground(Object element, int columnIndex) {
            return null;
        }

        @Override
        public boolean isLabelProperty(Object element, String property) {
            return false;
        }

        //~ METHODEN ==========================================================

        @Override
        public void removeListener(ILabelProviderListener listener) {}
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 23.10.13
