/*
 * @(#)DarstellungMqTyp.java   19.07.12
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.mqnavigation.gui;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.plugin.gtm.mqnavigation.gui.TreeContentProviderMq.SichtMq;
import de.inovat.buv.plugin.gtm.mqnavigation.lib.DatenVewMq;
import de.inovat.buv.plugin.gtm.mqnavigation.lib.DavSystemObjekt;
import de.inovat.buv.plugin.gtm.navigation.gui.lib.IDarstellung;
import de.inovat.buv.plugin.gtm.navigation.gui.lib.LabelProviderGTM;

import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.ITreeContentProvider;

//~ JDK IMPORTE ===============================================================

import java.util.List;

//~ KLASSEN ===================================================================

/**
 * IDarstellung-Implementation fr die "MQ Nach Typ".
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 375 $ / $Date: 2013-05-22 14:24:03 +0200 (Mi, 22 Mai 2013) $ / ($Author: LG $)
 */
public class DarstellungMqTyp implements IDarstellung {

    /** Nach PID sortierte Liste aller MQ-Typs. */
    private List<DavSystemObjekt> _listeMqTyps;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Erzeugt eine Instanz der Klasse DarstellungMqTyp.
     */
    public DarstellungMqTyp() {
        _listeMqTyps = DatenVewMq.getInstanz().getListeAlleMqTypsSortiert();
    }

    //~ GET METHODEN ==========================================================

    @Override
    public ITreeContentProvider getContentProvider() {
        return new TreeContentProviderMq(SichtMq.MQ_NACH_TYP);
    }

    @Override
    public Object getInput() {
        return _listeMqTyps;
    }

    @Override
    public ILabelProvider getLabelProvider() {
        return new LabelProviderGTM();
    }

    @Override
    public String getName() {
        return "MQ Nach Typ";
    }

    //~ METHODEN ==============================================================

    @Override
    public boolean istDynamisch() {
        return false;
    }

    @Override
    public boolean istModellAenderungUeberwacht() {
        return false;
    }

    @Override
    public boolean istSucheEingeschaltet() {
        return true;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 22.05.13
