/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.navigation.lib;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.gtm.datvew.lib.ZaehlStelle;
import de.inovat.buv.plugin.gtm.navigation.lib.AuswahlDialogGUI.ZS_MODUS;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;

//~ JDK IMPORTE ===============================================================

import java.util.ArrayList;
import java.util.List;

//~ KLASSEN ===================================================================

/**
 * Die Klasse enthlt die statischen Methoden fr den Langzeitzaehlstellenauswahldialog.
 *
 * @author inovat
 * @author Dagmar Rostek (DR)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public class LangzeitzaehlstellenAuswahlFunktionen {

    /**
     * ffne den Dialog 'LangZeitZaehlStelleauswahl' mit der Vorselektion der LangZeitZaehlStellen die
     * im Navigationsbaum ausgewhlt worden sind.
     *
     * @param shell ParentShell, Shell in der der Dialog angezeigt wird.
     * @param listeVorselektierteLangZeitZaehlStellen Liste der vorselektierten ZaehlStelle oder
     * null, falls keine ZaehlStelle vorselektiert werden sollen.
     * @param modus Modus (null - Alle Langzeitzhlstellen).
     *
     * @return Die Menge der selektierten ZaehlStelle.
     */
    public static List<ZaehlStelle> langzeitZaehlstellenAuswahlDialogOeffnen(Shell shell, List<ZaehlStelle> listeVorselektierteLangZeitZaehlStellen, ZS_MODUS modus) {
        List<ZaehlStelle> listeSelektierteLangZeitZaehlStellen = new ArrayList<ZaehlStelle>();
        Shell             shellDialog                          = new Shell(shell, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
        AuswahlDialogGUI  dialog                               = new AuswahlDialogGUI(shellDialog, false, modus);

        // Selektiere die angegebenen LangZeitZhlStellen>
        if (listeVorselektierteLangZeitZaehlStellen != null) {

            // Selektiere die LangZeitZhlStellen:
            dialog.selektiereLangZeitZaehlStellen(listeVorselektierteLangZeitZaehlStellen);
        }

        if (dialog.open() == AuswahlDialogGUI.OK) {

            // Flle die Menge der selektierten LangZeitZaehlStellen:
            List<ZaehlStelle> listeLangZeitZaehlStellen = dialog.getListeLangZeitZaehlStellenAuswahl();

            for (ZaehlStelle lzz : listeLangZeitZaehlStellen) {
                listeSelektierteLangZeitZaehlStellen.add(lzz);
            }
        }

        return listeSelektierteLangZeitZaehlStellen;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 10.09.12
