/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.navigation.sortierung;

//~ JDK IMPORTE ===============================================================

import java.util.List;

//~ KLASSEN ===================================================================

/**
 * Ein Sortierung Objekt enthlt die Sortiereintrge.
 *
 * @author inovat
 * @author Dagmar Rostek (DR)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public class Sortierung {

    /** SortierungEintrag. */
    private List<SortierungEintrag> _sortierungEintraege;

    /** Name der Sortierung. */
    private String _sortierungName;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * WICHTIG_: Die Methode darf nicht aufgerufen werden. Die wird von XMLDecoder bentigt.
     *
     * Erzeugt eine Instanz der Klasse Sortierung.
     */
    public Sortierung() {}

    /**
     * Erzeugt eine Instanz der Klasse Sortierung.
     *
     * @param sortierungName Name der Sortierung.
     * @param sortierungEintraege SortierungEintrag.
     */
    public Sortierung(String sortierungName, List<SortierungEintrag> sortierungEintraege) {
        _sortierungName      = sortierungName;
        _sortierungEintraege = sortierungEintraege;
    }

    //~ GET METHODEN ==========================================================

    /**
     *     Getter fr Eigenschaft 'sortierungEintraege'.
     *
     *     @return Wert der Eigenschaft 'sortierungEintraege'.
     *
     *     @see #_sortierungEintraege
     */
    public List<SortierungEintrag> getSortierungEintraege() {
        return _sortierungEintraege;
    }

    /**
     * Getter fr Eigenschaft 'sortierungName'.
     *
     * @return Wert der Eigenschaft 'sortierungName'.
     *
     * @see #_sortierungName
     */
    public String getSortierungName() {
        return _sortierungName;
    }

    //~ SET METHODEN ==========================================================

    /**
     * Setter fr Eigenschaft 'sortierungEintraege'.
     *
     * @param sortierungEintraege Wert zum Setzen der Eigenschaft 'sortierungEintraege'.
     *  WICHTIG! Verwendung fr die Speicherung im XML.
     * @see #_sortierungEintraege
     */
    public void setSortierungEintraege(List<SortierungEintrag> sortierungEintraege) {
        _sortierungEintraege = sortierungEintraege;
    }

    /**
     * Setter fr Eigenschaft 'sortierungName'.
     *
     * @param sortierungName Wert zum Setzen der Eigenschaft 'sortierungName'.
     *   WICHTIG! Verwendung fr die Speicherung im XML.
     * @see #_sortierungName
     */
    public void setSortierungName(String sortierungName) {
        _sortierungName = sortierungName;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 03.09.10
