/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.navigation.tabellenverwaltung;

//~ JDK IMPORTE ===============================================================

import java.util.ArrayList;
import java.util.List;

//~ KLASSEN ===================================================================

/**
 * Ein TabellenVerwaltungs Objekt enthlt die Tabellenverwaltungseintrge.
 *
 * @author inovat
 * @author Dagmar Rostek (DR)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public class TabellenVerwaltung {

    /** TabellenverwaltungsEintrag. */
    private List<TabellenVerwaltungEintrag> _tabellenVerwaltungsEintraege = new ArrayList<TabellenVerwaltungEintrag>();

    /** Name der TabellenVerwaltung. */
    private String _tabellenVerwaltungName;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * WICHTIG_: Die Methode darf nicht aufgerufen werden. Die wird von XMLDecoder bentigt.
     *
     * Erzeugt eine Instanz der Klasse Sortierung.
     */
    public TabellenVerwaltung() {}

    /**
     * Erzeugt eine Instanz der Klasse TabellenVerwaltung.
     *
     * @param tabellenVerwaltungsEintrag   Tabellenverwaltungseintrag.
     * @param tabellenVerwaltungName  Tabellenverwaltungsname.
     */
    public TabellenVerwaltung(String tabellenVerwaltungName, List<TabellenVerwaltungEintrag> tabellenVerwaltungsEintrag) {
        _tabellenVerwaltungsEintraege = tabellenVerwaltungsEintrag;
        _tabellenVerwaltungName       = tabellenVerwaltungName;
    }

    //~ GET METHODEN ==========================================================

    /**
     * Getter fr Eigenschaft 'tabellenVerwaltungName'.
     *
     * @return Wert der Eigenschaft 'tabellenVerwaltungName'.
     *
     * @see #_tabellenVerwaltungName
     */
    public String getTabellenVerwaltungName() {
        return _tabellenVerwaltungName;
    }

    /**
     * Getter fr Eigenschaft 'tabellenVerwaltungsEintrag'.
     *
     * @return Wert der Eigenschaft 'tabellenVerwaltungsEintrag'.
     *
     * @see #_tabellenVerwaltungsEintraege
     */
    public List<TabellenVerwaltungEintrag> getTabellenVerwaltungsEintrag() {
        return _tabellenVerwaltungsEintraege;
    }

    //~ SET METHODEN ==========================================================

    /**
     * Setter fr Eigenschaft 'tabellenVerwaltungName'.
     *
     * @param tabellenVerwaltungName Wert zum Setzen der Eigenschaft 'tabellenVerwaltungName'.
     *  WICHTIG! Verwendung fr die Speicherung im XML.
     * @see #_tabellenVerwaltungName
     */
    public void setTabellenVerwaltungName(String tabellenVerwaltungName) {
        _tabellenVerwaltungName = tabellenVerwaltungName;
    }

    /**
     * Setter fr Eigenschaft 'tabellenVerwaltungsEintrag'.
     *
     * @param tabellenVerwaltungsEintrag Wert zum Setzen der Eigenschaft 'tabellenVerwaltungsEintrag'.
     *  WICHTIG! Verwendung fr die Speicherung im XML.
     * @see #_tabellenVerwaltungsEintraege
     */
    public void setTabellenVerwaltungsEintrag(List<TabellenVerwaltungEintrag> tabellenVerwaltungsEintrag) {
        _tabellenVerwaltungsEintraege = tabellenVerwaltungsEintrag;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 03.09.10
