/*
 * @(#)ZsDokumentationDialog.java   15.09.10
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.visualisierung.karte;

//~ NICHT JDK IMPORTE =========================================================

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;

//~ KLASSEN ===================================================================

/**
 * GUI und die Verwaltung vom Dialog 'Dauerzhlstellendokumentation'.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 88 $ / $Date: 2012-03-09 16:20:38 +0100 (Fr, 09 Mrz 2012) $ / ($Author: LG $)
 */
public class ZsDokumentationDialog extends Dialog {
    private String _url = "";

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Erzeugt eine Instanz der Klasse ZsDokumentationDialog.
     *
     * @param parentShell Shell.
     */
    public ZsDokumentationDialog(Shell parentShell) {
        super(parentShell);
    }

    //~ METHODEN ==============================================================

    @Override
    protected void configureShell(Shell newShell) {
        super.configureShell(newShell);
        newShell.setText("Dauerzhlstellendokumentation");
    }

    @Override
    protected void createButtonsForButtonBar(Composite parent) {
        createButton(parent, IDialogConstants.CANCEL_ID, "Schlieen", false);
    }

    @Override
    protected Control createDialogArea(Composite parent) {
        Composite container     = (Composite) super.createDialogArea(parent);
        Composite compAllgemein = new Composite(container, SWT.NONE);

        compAllgemein.setLayout(new GridLayout(1, false));
        compAllgemein.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

        Browser browser = new Browser(compAllgemein, SWT.NONE);

        browser.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
        browser.setUrl(_url);

        return container;
    }

    //~ GET METHODEN ==========================================================

    @Override
    protected Point getInitialSize() {
        return new Point(700, 900);
    }

    @Override
    protected boolean isResizable() {
        return true;
    }

    //~ SET METHODEN ==========================================================

    /**
     * Setter fr Eigenschaft 'url'.
     *
     * @param url Wert zum Setzen der Eigenschaft 'url'.
     *
     * @see #_url
     */
    public void setUrl(String url) {
        _url = url;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 16.09.10
