/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.projektlib.views;

//~ NICHT JDK IMPORTE =========================================================

import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.part.ViewPart;

import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_WEIS;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.ICON_LOGO_INOVAT;

//~ KLASSEN ===================================================================

/**
 * Die Sicht fr Logo 'Inovat'.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 22 $ / $Date: 2013-09-24 15:51:26 +0200 (Di, 24 Sep 2013) $ / ($Author: LG $)
 */
public class ViewLogoInovat extends ViewPart {

    /** ID der Sicht fr Logo 'Inovat'. */
    public static final String ID = "de.inovat.buv.projektlib.views.viewLogoInovat";

    //~ METHODEN ==============================================================

    @Override
    public void createPartControl(Composite parent) {
        {
            parent.setSize(170, 50);

            Composite  composite1       = new Composite(parent, SWT.NONE);
            GridLayout composite1Layout = new GridLayout();

            composite1Layout.makeColumnsEqualWidth = true;
            composite1.setLayout(composite1Layout);
            {
                Label    projektLogoInovat      = new Label(composite1, SWT.NONE);
                GridData ProjektLogoInovatLData = new GridData();

                ProjektLogoInovatLData.grabExcessHorizontalSpace = true;
                ProjektLogoInovatLData.horizontalAlignment       = GridData.FILL;
                ProjektLogoInovatLData.grabExcessVerticalSpace   = true;
                ProjektLogoInovatLData.verticalAlignment         = GridData.FILL;
                projektLogoInovat.setLayoutData(ProjektLogoInovatLData);
                projektLogoInovat.setImage(ICON_LOGO_INOVAT);
                projektLogoInovat.setAlignment(SWT.CENTER);
                projektLogoInovat.setSize(200, 74);
                projektLogoInovat.setBackground(FARBE_WEIS);
            }
        }
        initializeToolBar();
    }

    /**
     * Initialisiere ToolBar.
     */
    private void initializeToolBar() {
        getViewSite().getActionBars().getToolBarManager();
    }

    //~ SET METHODEN ==========================================================

    @Override
    public void setFocus() {}
}


//~Formatiert mit 'inovat Kodierkonvention' am 03.02.10
