/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;

import java.util.ArrayList;
import java.util.List;

/**
 * Klasse verwaltet dtd-Element attributauswahlDefinition.
 * 
 * <!ELEMENT attributauswahlDefinition ( info, (auswahl)+ ) >
 * <!ATTLIST attributauswahlDefinition
 * 		pid ID #REQUIRED
 * 		name CDATA #IMPLIED
 * 		typ (wert|id) #REQUIRED
 * >
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class AttributauswahlDefinitionBeschreibung {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Private ----------------------------------------------------------------
	/** bersicht der AttributauswahlDefinitionBeschreibung. */
	private Uebersicht _uebersicht;

	/** List der AuswahlBeschreibungen. */
	private List<AuswahlBeschreibung> _listeAuswahlBeschreibung=new ArrayList<AuswahlBeschreibung>();

	/** Typ (wert|id) */
	private String _typ;

// ------------------------------------------------------------------------
// KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
// ------------------------------------------------------------------------

	/**
	 * Erzeugt eine Instanz der Klasse AttributauswahlDefinitionBeschreibung.
	 *
	 * @param uebersicht
	 * @param auswahlBeschreibung
	 * @param typ
	 */
	public AttributauswahlDefinitionBeschreibung(Uebersicht uebersicht,
			List<AuswahlBeschreibung> auswahlBeschreibung, String typ) {
		_uebersicht = uebersicht;
		if(auswahlBeschreibung==null){
			_listeAuswahlBeschreibung=new ArrayList<AuswahlBeschreibung>();
		}
		else{
			_listeAuswahlBeschreibung = auswahlBeschreibung;
		}
		_typ = typ;
	}

// ------------------------------------------------------------------------
// GETTER / SETTER METHODEN
// ------------------------------------------------------------------------

	/**
	 * Getter fr Eigenschaft 'listeAuswahlBeschreibung'.
	 *
	 * @return Wert der Eigenschaft 'listeAuswahlBeschreibung'.
	 *
	 * @see  {#link _listeAuswahlBeschreibung}
	 */
	public List<AuswahlBeschreibung> getListeAuswahlBeschreibung() {
		return _listeAuswahlBeschreibung;
	}

	/**
	 * Getter fr Eigenschaft 'typ'.
	 *
	 * @return Wert der Eigenschaft 'typ'.
	 *
	 * @see  {#link _typ}
	 */
	public String getTyp() {
		return _typ;
	}

	/**
	 * Getter fr Eigenschaft 'uebersicht'.
	 *
	 * @return Wert der Eigenschaft 'uebersicht'.
	 *
	 * @see  {#link _uebersicht}
	 */
	public Uebersicht getUebersicht() {
		return _uebersicht;
	}
}
