/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;

/**
 * Klasse verwaltet dtd-Element attributgruppe.
 * 
 * <!ELEMENT attributgruppe EMPTY>
 * <!ATTLIST attributgruppe pid NMTOKEN #REQUIRED
 * >
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class AttributgruppenBeschreibung {
	
	/** PID der Attributgruppe. */
	private String _pid;
	
	/** Die Definition vom Attributgruppe (kann null sein). */
	private AttributgruppenDefinitionBeschreibung _attributgruppenDefinitionBeschreibung;
	
	/**
	 * Erzeugt eine Instanz der Klasse AttributgruppenBeschreibung.
	 * 
	 * @param pid
	 * @param attributgruppenDefinitionBeschreibung
	 */
	public AttributgruppenBeschreibung(
			String pid,
			AttributgruppenDefinitionBeschreibung attributgruppenDefinitionBeschreibung) {
		_pid = pid;
		_attributgruppenDefinitionBeschreibung = attributgruppenDefinitionBeschreibung;
	}

	/**
	 * Getter fr Eigenschaft 'pid'.
	 * 
	 * @return Wert der Eigenschaft 'pid'.
	 * 
	 * @see  {#link _pid}
	 */
	public String getPid() {
		return _pid;
	}

	/**
	 * Getter fr Eigenschaft 'attributgruppenDefinitionBeschreibung'.
	 * 
	 * @return Wert der Eigenschaft 'attributgruppenDefinitionBeschreibung'.
	 * 
	 * @see  {#link _attributgruppenDefinitionBeschreibung}
	 */
	public AttributgruppenDefinitionBeschreibung getAttributgruppenDefinitionBeschreibung() {
		return _attributgruppenDefinitionBeschreibung;
	}

}
