/*
 * @(#)DaVMengenElement.java   20.02.13
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.gtm.datvew.lib;

//~ NICHT JDK IMPORTE =========================================================

import de.bsvrz.dav.daf.main.config.SystemObject;
import de.inovat.buv.gtm.datvew.konstanten.KonstantenGTMGUIResource;

import org.eclipse.swt.graphics.Image;

//~ KLASSEN ===================================================================

/**
 * Klasse beschreibt ein DaV-Mengenelement Objekt als interne Reprsentation.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public class DaVMengenElement implements ISystemObjekt {

    /** Parent Menge. */
    private DaVMenge _parentMenge;

    /** DaV-SystemObjekt. */
    private SystemObject _so;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Erzeugt eine Instanz der Klasse DaVMengenElement.
     *
     * @param parentMenge Parent Menge.
     * @param so SystemObject.
     */
    public DaVMengenElement(DaVMenge parentMenge, SystemObject so) {
        _parentMenge = parentMenge;
        _so          = so;
    }

    //~ GET METHODEN ==========================================================

    @Override
    public Image getImage() {
    	return KonstantenGTMGUIResource.ermittleImage(_so);
    }

    /**
     * Getter fr Eigenschaft 'parentDavSo'.
     *
     * @return Wert der Eigenschaft 'parentDavSo'.
     *
     * @see #_parentMenge
     */
    public DaVMenge getParent() {
        return _parentMenge;
    }

    @Override
    public SystemObject getSystemObjekt() {
        return _so;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 20.02.13
