/*
 * @(#)IMenuPunkt.java   28.03.12
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.gtm.datvew.menu;

//~ NICHT JDK IMPORTE =========================================================

import org.eclipse.jface.action.IAction;

//~ INTERFACES ================================================================

/**
 * Interface definiert einen Menpunkt fr die inovatGTM-Navigation.
 * </p>
 * Interface wird von Klassen implementiert, die im ExtensionPoint
 * de.inovat.buv.gtm.datvew.NavigationMenu angegeben werden.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public interface IMenuPunkt {

    /**
     * Ermittle die Aktionen fr den Menpunkt.
     *
     * @return Aktionen fr den Menpunkt.
     */
    public IAction getAktion();

    /**
     * Ermittle den Namen des Menpunktes.
     *
     * @return Name des Menpunktes.
     */
    public String getName();

    /**
     * Ermittle den DaV-Typ, fr den der Menpunkt erstellt wird.
     *
     * @return DaV-Typ, fr den der Menpunkt erstellt wird.
     */
    public String getTyp();
}


//~Formatiert mit 'inovat Kodierkonvention' am 28.03.12
