/*
 * @(#)View.java   16.04.10
 *
 * Copyright (c) 2010 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.inovat.lib.debug.beispiel;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.inovat.lib.Activator;
import de.inovat.buv.inovat.lib.debug.Log;
import de.inovat.buv.inovat.lib.debug.ProtokollGUI;
import de.inovat.buv.inovat.lib.debug.ProtokollGUIVerwaltung;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.ui.part.ViewPart;

//~ JDK IMPORTE ===============================================================

import java.util.ArrayList;
import java.util.List;

//~ KLASSEN ===================================================================

/**
 * Beispiel der Verwendung des Protokoll-GUI.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 9 $ / $Date: 2010-11-05 13:20:42 +0100 (Fr, 05. Nov 2010) $ / ($Author: LG $)
 */
public class View extends ViewPart {
    public static final String ID = "de.inovat.buv.inovat.lib.beispiel.debug.view";

    //~ FELDER ================================================================

    /** Instanz der Protokoll-GUI-Verwaltung. */
    private ProtokollGUIVerwaltung _protokoll;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Erzeugt eine Instanz der Klasse View.
     */
    public View() {}

    //~ METHODEN ==============================================================

    @Override
    public void createPartControl(Composite parent) {
        parent.setLayout(new GridLayout(1, false));

        final Composite composite = new Composite(parent, SWT.NONE);

        composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
        composite.setLayout(new GridLayout(1, false));

        // Zeige Protokoll-GUI:
        ProtokollGUI protokollGui = new ProtokollGUI(composite);

        // Hole die Protokoll-GUI-Verwaltung Instanz:
        _protokoll = protokollGui.getGuiVew();

        //
        final Group grp = new Group(parent, SWT.NONE);

        grp.setText("Testmeldungen erstellen");
        grp.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
        grp.setLayout(new GridLayout(1, false));

        final Button btnHinzufuegen = new Button(grp, SWT.NONE);

        btnHinzufuegen.setText("Meldung hinzufgen");
        btnHinzufuegen.addSelectionListener(new SelectionAdapter() {
            @Override
            public void widgetSelected(SelectionEvent e) {

                // Erstelle eine Meldung und zeige die im Protokoll.
                IStatus fehlerMeldung = null;

                try {
                    int i = 8 / 0;
                }
                catch (Exception e2) {
                    fehlerMeldung = Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Es ist ein Fehler aufgetreten!", e2);
                }

                List<IStatus> liste = new ArrayList<IStatus>();

                if (fehlerMeldung != null) {
                    liste.add(fehlerMeldung);
                }

                IStatus meldung = Log.erzeugeMultiMeldung(Activator.PLUGIN_ID, "Testmeldung", liste);

                _protokoll.hinzufuegenMeldung(meldung);
            }
        });
    }

    //~ GET METHODEN ==========================================================

    /**
     * Liefert das Protokollobjekt, ber das Meldungen verwaltet werden.
     * @return Das Protokollobjekt, ber das Meldungen verwaltet werden.
     */
    public ProtokollGUIVerwaltung getProtokoll() {
        return _protokoll;
    }

    //~ SET METHODEN ==========================================================

    @Override
    public void setFocus() {}
}


//~Formatiert mit 'inovat Kodierkonvention' am 24.09.13
