/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package de.inovat.buv.inovat.lib.gui.vewdlg;

//~ NICHT JDK IMPORTE =========================================================

import org.eclipse.swt.widgets.Composite;

//~ INTERFACES ================================================================

/**
 * Das Interface wird von der Klasse RahmenVerwaltungsDialogGUI benutzt.
 * Das enthlt Methoden fr die konkrete Bearbeitung der Objekten.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 12 $ / $Date: 2013-09-24 13:23:48 +0200 (Di, 24. Sep 2013) $ / ($Author: LG $)
 */
public interface IRahmenVerwaltungsDialogGUI {

    /**
     * Fge das neue leere Objekt mit dem Namen objektName in die Liste ein.
     * </p>
     * @param objektName Name des neuen Objekts.
     */
    public void einfuegenNeuesElement(String objektName);

    /**
     * Liefert ein Array von ObjektNamen.
     * </p>
     * @return Array von String
     */
    public String[] ermittleInputArray();

    /**
     * Initialisiere die Daten fr leeres Element.
     */
    public void initialisiereElement();

    /**
     * Zeichne das GUI Bereich.
     * </p>
     * @param parent Parent-Composite.
     */
    public void initialisiereGUIBereich(Composite parent);

    /**
     * Kopiere das selektierte Objekt ins neue Objekt mit dem Namen objektName
     * und fge das neue Element in die Liste ein.
     * </p>
     * @param objektName Name des neuen Elements.
     */
    public void kopiereElement(String objektName);

    /**
     * Lsche das Objekt mit dem Namen objektName aus der Liste.
     * </p>
     * @param objektName Name des zu lschenden Elements.
     */
    public void loescheElement(String objektName);

    /**
     * Das Objekt mit dem Namen objektName wird selektiert.
     * </p>
     * @param objektName Name des zu selektierten Elements.
     */
    public void selektiereElement(String objektName);

    /**
     * Initialisiere die Werte des GUI Bereich mit den Werten von Element-Daten.
     * </p>
     * @param objektName Name des Element, mit derren Werten wird das GUI initialisiert.
     */
    public void setzeGUIbereichMitElementDaten(String objektName);

    /**
     * Stellt fest, ob der Inhalt des GUI Daten mit dem Inhalt der Element-Daten gleich ist.
     * </p>
     * @return <tt>true</tt> wenn der Inhalt des GUI Daten mit dem Inhalt der Element-Daten gleich ist, sonst <tt>false</tt>.
     */
    public boolean sindGuiDatenMitElementDatenGleich();

    /**
     * Speichere das Objekt (setze die Element-Daten mit den Werten aus dem GUI Bereich und speichere das Element).
     */
    public void speichereElement();
}


//~Formatiert mit 'inovat Kodierkonvention' am 01.07.09
