/*
 * @(#)ViewImportPruef.java   15.10.12
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.bast;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.plugin.gtm.bast.aktionen.AktionenBast;
import de.inovat.buv.plugin.gtm.bast.hilfe.HilfeVew;
import de.inovat.buv.plugin.gtm.bast.importpruef.ImportPruefGUI;
import de.inovat.buv.projektlib.rechtevew.aktionen.AbstrakteSichtMitBerechtigung;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

//~ KLASSEN ===================================================================

/**
 * Sicht 'BASt-Band-Import Prfung'.
 *
 * @author inovat
 * @author Dagmar Rostek (DR)
 */
public class ViewImportPruef extends AbstrakteSichtMitBerechtigung {

    /** ID der Sicht. */
    public static final String ID = "de.inovat.buv.plugin.gtm.bast.importpruef.view";

    //~ FELDER ================================================================

    /** GUI-Instanz. */
    private ImportPruefGUI _gui;

    //~ METHODEN ==============================================================

    @Override
    public void dispose() {
        if (_gui != null) {
            _gui.getFormToolkit().dispose();
        }

        super.dispose();
    }

    //~ GET METHODEN ==========================================================

    @Override
    public String getBerechtigungsFunktionId() {
        return AktionenBast.FUNKTION_ID_IMPORT_PRUEF;
    }

    @Override
    public String getHilfeContextId() {
        return HilfeVew.getInstanz().ermittleIdFuerAnker(HilfeVew.ANKER_IMPORT_BAST_PRUEF);
    }

    //~ METHODEN ==============================================================

    @Override
    public Control initGUI(Composite parent) {
        _gui = new ImportPruefGUI(parent);

        return _gui;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 28.10.13
