/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.lzzs;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.plugin.gtm.lzzs.aggregation.AggregationDtvGUI;
import de.inovat.buv.plugin.gtm.lzzs.aktionen.AktionenLZZS;
import de.inovat.buv.plugin.gtm.lzzs.hilfe.HilfeVew;
import de.inovat.buv.projektlib.rechtevew.aktionen.AbstrakteSichtMitBerechtigung;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

//~ KLASSEN ===================================================================

/**
 * Zeigt die Sicht "Aggregation DTV".
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 88 $ / $Date: 2012-03-09 16:20:38 +0100 (Fr, 09 Mrz 2012) $ / ($Author: LG $)
 */
public class ViewAggregationDtv extends AbstrakteSichtMitBerechtigung {

    /** ID der Sicht "Aggregation DTV". */
    public static final String ID = "de.inovat.buv.plugin.gtm.lzzs.aggregation.view";

    //~ FELDER ================================================================

    /** GUI-Instanz. */
    private AggregationDtvGUI _gui;

    //~ METHODEN ==============================================================

    @Override
    public void dispose() {
        if (_gui != null) {
            if (_gui.getToolkit() != null) {
                _gui.getToolkit().dispose();
            }

            // Melde das AggregationVerwaltungsObjekt von DAV ab:
            _gui.getGuiVew().abmeldenDav();
        }

        super.dispose();
    }

    //~ GET METHODEN ==========================================================

    @Override
    public String getBerechtigungsFunktionId() {
        return AktionenLZZS.FUNKTION_ID_AGGREGATION_DTV;
    }

    @Override
    public String getHilfeContextId() {
        return HilfeVew.getInstanz().ermittleIdFuerAnker(HilfeVew.ANKER_AGGREGATION);
    }

    //~ METHODEN ==============================================================

    @Override
    public Control initGUI(Composite parent) {
        _gui = new AggregationDtvGUI(parent);

        return _gui;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 28.10.13
