/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.navigation;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.gtm.datvew.aktionen.AktionenGTM;
import de.inovat.buv.inovat.lib.gui.vewdlg.RahmenVerwaltungsDialogGUI;
import de.inovat.buv.plugin.gtm.hilfe.HilfeVew;
import de.inovat.buv.plugin.gtm.navigation.gtmdiag.GewaehlteDarstellung;
import de.inovat.buv.plugin.gtm.navigation.sortierung.SortierungEinstellungen;
import de.inovat.buv.projektlib.rechtevew.aktionen.AbstrakteSichtMitBerechtigung;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

//~ KLASSEN ===================================================================

/**
 * ffnet die Sicht Spaltenauswahl.
 *
 * @author inovat
 * @author Dagmar Rostek (DR)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public class ViewSpaltenauswahl extends AbstrakteSichtMitBerechtigung {

    /** ID der Sicht 'SortierungEinstellungen.' */
    public static final String ID = "de.inovat.buv.plugin.gtm.navigation.spalten.view";

    //~ FELDER ================================================================

    /** GUI-Einstellungeninstanz. */
    private SortierungEinstellungen    _guiEinstellungen;
    private RahmenVerwaltungsDialogGUI _guiVew;

    //~ GET METHODEN ==========================================================

    /*
    @Override
    public void createPartControl(Composite parent) {

        // Hilfe
        PlatformUI.getWorkbench().getHelpSystem().setHelp(parent, HilfeVew.getInstanz().ermittleIdFuerAnker(HilfeVew.ANKER_SPALTENAUSWAHL));

        //
        if (!AktionenVew.getInstanz().erstelleLeeresView(parent, AktionenGTMVew.AKTION_ID_SPALTEN)) {
            IActionBars statusInformationArchiv = getViewSite().getActionBars();

            // erzeuge GUI
            _guiEinstellungen = new SortierungEinstellungen(1, statusInformationArchiv, parent);
            _guiVew           = new RahmenVerwaltungsDialogGUI(parent, ID, _guiEinstellungen, GewaehlteDarstellung.getInstanz().getGewaehlteSpalten());
            _guiEinstellungen.setGuiVew(_guiVew);
        }

        //
        parent.addDisposeListener(new DisposeListener() {
            public void widgetDisposed(final DisposeEvent e) {

                // Lscht die Registrierung der Klasse als Listener auf RechteAenderung:
                RechteVew.removeRechteListener(_guiEinstellungen);
            }
        });
    }
    */
    @Override
    public String getBerechtigungsFunktionId() {
        return AktionenGTM.FUNKTION_ID_SPALTENAUSWAHL;
    }

    @Override
    public String getHilfeContextId() {
        return HilfeVew.getInstanz().ermittleIdFuerAnker(HilfeVew.ANKER_SPALTENAUSWAHL);
    }

    //~ METHODEN ==============================================================

    @Override
    public Control initGUI(Composite parent) {
        _guiEinstellungen = new SortierungEinstellungen(1);
        _guiVew           = new RahmenVerwaltungsDialogGUI(parent, ID, _guiEinstellungen, GewaehlteDarstellung.getInstanz().getGewaehlteSpalten());
        _guiEinstellungen.setGuiVew(_guiVew);

        return _guiVew;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 16.10.13
