/*
 * @(#)IArchivanfrageGUIVew.java   27.09.12
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.navigation.archiv;

//~ INTERFACES ================================================================

/**
 * Interface wird von Klassen implementiert, die
 * das GUI "Archivanfrage" in sein GUI einbauen mchten.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public interface IArchivanfrageGUIVew {

    /**
     * Methode reagiert auf die nderungen im GUI "Archivanfrage".
     */
    public void archivGuiDatenGeaendert();

    /**
     * Button "Export csv (ohne Einheit)..." wird selektiert.
     * <p/>
     * Die Methode wird nicht aufgerufen, falls
     * {@link #istBtnArchivanfrage()} false liefert.
     */
    public void btnArchivanfrageExportCsvOhneEinheitSelektiert();

    /**
     * Button "Export csv..." wird selektiert.
     * <p/>
     * Die Methode wird nicht aufgerufen, falls
     * {@link #istBtnArchivanfrage()} false liefert.
     */
    public void btnArchivanfrageExportCsvSelektiert();

    /**
     * Button "Export html (ohne Einheit)..." wird selektiert.
     * <p/>
     * Die Methode wird nicht aufgerufen, falls
     * {@link #istBtnArchivanfrage()} false liefert.
     */
    public void btnArchivanfrageExportHtmlOhneEinheitSelektiert();

    /**
     * Button "Export html..." wird selektiert.
     * <p/>
     * Die Methode wird nicht aufgerufen, falls
     * {@link #istBtnArchivanfrage()} false liefert.
     */
    public void btnArchivanfrageExportHtmlSelektiert();

    /**
     * Button "Neue Archivanfrage" wird selektiert.
     * <p/>
     * Die Methode wird nicht aufgerufen, falls
     * {@link #istBtnArchivanfrage()} false liefert.
     */
    public void btnArchivanfrageSelektiert();

    /**
     * Methode stellt fest, ob das Button "Neue Archivanfrage"
     * in GUI eingebaut werden soll.
     *
     * @return true, falls das Button "Neue Archivanfrage"
     * in GUI eingebaut werden soll, false - sonst.
     */
    public boolean istBtnArchivanfrage();
}


//~Formatiert mit 'inovat Kodierkonvention' am 10.03.14
