/*
 * @(#)DarstellungMq.java   19.07.12
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.navigation.gui.sichte;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.gtm.datvew.lib.AuswerteQuerschnitt;
import de.inovat.buv.gtm.datvew.lib.DatenVew;
import de.inovat.buv.gtm.datvew.lib.Messquerschnitt;
import de.inovat.buv.gtm.datvew.lib.ZaehlStelle;
import de.inovat.buv.plugin.gtm.navigation.gui.lib.IDarstellung;
import de.inovat.buv.plugin.gtm.navigation.gui.lib.LabelProviderGTM;
import de.inovat.buv.plugin.gtm.navigation.gui.sichte.TreeContentProviderZs.Sicht;

import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.ITreeContentProvider;

//~ JDK IMPORTE ===============================================================

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

//~ KLASSEN ===================================================================

/**
 * IDarstellung-Implementation fr die "MQ Zhlstellen".
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public class DarstellungMq implements IDarstellung {

    /** Nach PID sortierte Liste aller MQ. */
    private List<Messquerschnitt> _listeMq;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Erzeugt eine Instanz der Klasse DarstellungMq.
     */
    public DarstellungMq() {

        // Initialisiere die Liste alle MQs:
        _listeMq = new ArrayList<Messquerschnitt>();

        for (ZaehlStelle zs : DatenVew.getInstanz().getListeZaehlStellen()) {
            for (AuswerteQuerschnitt awq : zs.getArAWQ()) {
                _listeMq.add(awq.getMessquerschnitt());
            }
        }

        // Sortiere die Liste:
        Collections.sort(_listeMq, DatenVew.COMPARATOR_SO_PID);
    }

    //~ GET METHODEN ==========================================================

    @Override
    public ITreeContentProvider getContentProvider() {
        return new TreeContentProviderZs(Sicht.MQ);
    }

    @Override
    public Object getInput() {
        return _listeMq;
    }

    @Override
    public ILabelProvider getLabelProvider() {
        return new LabelProviderGTM();
    }

    @Override
    public String getName() {
        return "MQ Zhlstellen";
    }

    //~ METHODEN ==============================================================

    @Override
    public boolean istDynamisch() {
        return false;
    }

    @Override
    public boolean istModellAenderungUeberwacht() {
        return false;
    }

    @Override
    public boolean istSucheEingeschaltet() {
        return true;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 21.05.13
