/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.navigation.lib;

//~ NICHT JDK IMPORTE =========================================================

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;

//~ JDK IMPORTE ===============================================================

import java.util.ArrayList;
import java.util.List;

//~ KLASSEN ===================================================================

/**
 * Die Klasse enthlt die statischen Methoden fr den Dateiauswahldialog.
 *
 * @author inovat
 * @author Dagmar Rostek (DR)
 * @version $Revision: 155 $ / $Date: 2014-10-07 11:11:48 +0200 (Di, 07 Okt 2014) $ / ($Author: LG $)
 */
public class DateiAuswahlFunktionen {
    public static List<String> dateiAuswahlDialogOeffnen(Shell shell) {
        return dateiAuswahlDialogOeffnen(shell, null);
    }

    public static List<String> dateiAuswahlDialogOeffnen(Shell shell, List<String> listeVorselektierteDateien) {
        List<String>                 listeSelektierteDateien = new ArrayList<String>();
        Shell                        shellDialog             = new Shell(shell, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
        AuswahlDialogGUI dialog                  = new AuswahlDialogGUI(shellDialog, true, null);

        if ((listeVorselektierteDateien != null) && (!listeVorselektierteDateien.isEmpty())) {
            dialog.selektierteDateien(listeVorselektierteDateien);
        }

        if (dialog.open() == AuswahlDialogGUI.OK) {

            // Flle die Menge der selektierten Dateien
            List<String> listeDateien = dialog.getListeDateiAuswahl();

            for (String dateiName : listeDateien) {
                listeSelektierteDateien.add(dateiName);
            }
        }

        return listeSelektierteDateien;
    }

    /**
     * Die Methode ermittelt die Anzahl der selektierten Dateien.
     * @param listeDateien Liste der Dateien.
     * @return String wie viele Dateien importiert werden.
     */
    public static String ermittleAnzahlSelDateien(List<String> listeDateien) {
        String text;

        if ((listeDateien == null) || (listeDateien.size() == 0)) {
            text = "Die aktuelle Auswahl importiert keine Dateien.";
        } else if (listeDateien.size() == 1) {
            text = "Es werden die Daten einer Datei importiert.";
        } else {
            text = "Es werden " + listeDateien.size() + " Dateien importiert.";
        }

        return text;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 03.09.10
