/*
 * @(#)LabelProviderTabellenDatenStrukturGTM.java   08.03.13
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.navigation.tabellen;

//~ NICHT JDK IMPORTE =========================================================

import de.bsvrz.buv.rw.basislib.tabellen.LabelProviderTabellenDatenStruktur;

import org.eclipse.jface.viewers.IColorProvider;
import org.eclipse.swt.graphics.Color;

import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_CYAN;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_GELB;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_GOLD;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_GRAU_GRUEN_HELL;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_GRUEN_PALE;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_MAGENDA;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_ROT;
import static de.inovat.buv.projektlib.konstanten.KonstantenGUIResource.FARBE_ROT_HELL;

//~ KLASSEN ===================================================================

public class LabelProviderTabellenDatenStrukturGTM extends LabelProviderTabellenDatenStruktur implements IColorProvider {

    /** Konstante Ausgelagerter Bereich. */
    private static final String AUSGELAGERTER_BEREICH = "Ausgelagerter Bereich";

    /** Konstante Ende Archivanfragezeitraum. */
    private static final String ENDE_ARCHIVANFRAGEZEITRAUM = "Ende des Archivanfragezeitraums";

    /** Farbe fr die Statusinformation 'Keine Daten'. */
    public static final Color FARBE_KEINE_DATEN = FARBE_GRUEN_PALE;

    /** Farbe fr die Statusinformation 'Keine Daten (keine quelle)'. */
    public static final Color FARBE_KEINE_DATEN_KEINE_QUELLE = FARBE_GOLD;

    /** Farbe fr die Statusinformation 'Unterbrechung durch den Benutzer'. */
    public static final Color FARBE_UNTERBRECHUNG = FARBE_ROT_HELL;

    /** Farbe fr die Statusinformation 'Start durch den Benutzer'. */
    public static final Color FARBE_START = FARBE_GRAU_GRUEN_HELL;

    /** Farbe fr die Statusinformation 'Keine Rechte' */
    public static final Color FARBE_KEINE_RECHTE = FARBE_ROT;

    /** Farbe fr die Statusinformation 'Keine Daten undefinierte Objektkodierung. */
    public static final Color FARBE_KEINE_DATEN_UNDEFINIERTE_OBJEKTKODIERUNG = FARBE_ROT;

    /** Farbe fr die Statusinformation 'Keine Daten potentielle Datenlcke.' */
    public static final Color FARBE_KEINE_DATEN_POTENTIELLE_DATENLUECKE = FARBE_MAGENDA;

    /** Farbe fr die Statusinformation 'Keine Daten fehlerhafte Anmeldung.' */
    public static final Color FARBE_KEINE_DATEN_FEHLERHAFTE_ANMELDUNG = FARBE_ROT;

    /** Farbe fr die Statusinformation 'Gelschte Bereich'. */
    public static final Color FARBE_GELOESCHTE_BEREICH = FARBE_ROT;

    /** Farbe fr die Statusinformation 'Ende Archivanfragezeitraum.' */
    public static final Color FARBE_ENDE_ARCHIVANFRAGEZEITRAUM = FARBE_CYAN;

    /** Farbe fr die Statusinformation 'ausgelagerter Bereich.' */
    public static final Color FARBE_AUSGELAGERTER_BEREICH = FARBE_GELB;

    /** Farbe fr die Statusinformation 'gelschter Bereich.' */
    private static final String GELOESCHTE_BEREICH = "Gelschter Bereich";

    /** Konstanten Statusinformationen. */
    private static final String KEINE_DATEN = "keine Daten";

    /** Konstante Keine Daten, fehlerhafte Anmeldung. */
    private static final String KEINE_DATEN_FEHLERHAFTE_ANMELDUNG = "keine Daten (fehlerhafte Anmeldung)";

    /** Konstante keine Daten, keine Quelle. */
    private static final String KEINE_DATEN_KEINE_QUELLE = "keine Daten (keine Quelle)";

    /** Konstante keine Daten, keine Rechte. */
    private static final String KEINE_DATEN_KEINE_RECHTE = "keine Daten (keine Rechte)";

    /** Konstante keine Daten, potentielle Datenlcke. */
    private static final String KEINE_DATEN_POTENTIELLE_DATENLUECKE = "keine Daten (potentielle Datenlcke)";

    /** Konstante keine Daten, undefinierte Objektzuordnung. */
    private static final String KEINE_DATEN_UNDEFINIERTE_OBJEKTKODIERUNG = "keine Daten (Undefinierte Objektkodierung)";

    /** Konstante Start durch den Benutzer. */
    private static final String START_DURCH_BENUTZER = "Start durch den Benutzer";

    /** Konstante Unterbrechung durch den Benutzer. */
    private static final String UNTERBRECHUNG_DURCH_BENUTZER = "Unterbrechung durch den Benutzer";

    //~ GET METHODEN ==========================================================

    @Override
    public Color getBackground(Object element) {
        if (element instanceof ZeilenObjekt) {
            String       archivDaten  = "";
            ZeilenObjekt zeile        = (ZeilenObjekt) element;
            String       normaleDaten = (String) zeile.getAttribut(3);

            if (zeile.getAnzahlAttribute() > 4) {
                archivDaten = (String) zeile.getAttribut(4);
            }

            if (zeile.getAnzahlAttribute() > 3) {
                if ((normaleDaten.equals(KEINE_DATEN_KEINE_QUELLE) || archivDaten.equals(KEINE_DATEN_KEINE_QUELLE))) {
                    return FARBE_KEINE_DATEN_KEINE_QUELLE;
                } else if ((normaleDaten.equals(KEINE_DATEN)) || archivDaten.equals(KEINE_DATEN)) {
                    return FARBE_KEINE_DATEN;
                } else if ((normaleDaten.equals(UNTERBRECHUNG_DURCH_BENUTZER) || archivDaten.equals(UNTERBRECHUNG_DURCH_BENUTZER))) {
                    return FARBE_UNTERBRECHUNG;
                } else if ((normaleDaten.equals(START_DURCH_BENUTZER) || archivDaten.equals(START_DURCH_BENUTZER))) {
                    return FARBE_START;
                } else if ((normaleDaten.equals(KEINE_DATEN_KEINE_RECHTE) || archivDaten.equals(KEINE_DATEN_KEINE_RECHTE))) {
                    return FARBE_KEINE_RECHTE;
                } else if ((normaleDaten.equals(KEINE_DATEN_POTENTIELLE_DATENLUECKE) || archivDaten.equals(KEINE_DATEN_POTENTIELLE_DATENLUECKE))) {
                    return FARBE_KEINE_DATEN_POTENTIELLE_DATENLUECKE;
                } else if ((normaleDaten.equals(ENDE_ARCHIVANFRAGEZEITRAUM) || archivDaten.equals(ENDE_ARCHIVANFRAGEZEITRAUM))) {
                    return FARBE_ENDE_ARCHIVANFRAGEZEITRAUM;
                } else if ((normaleDaten.equals(GELOESCHTE_BEREICH) || archivDaten.equals(GELOESCHTE_BEREICH))) {
                    return FARBE_GELOESCHTE_BEREICH;
                } else if ((normaleDaten.equals(AUSGELAGERTER_BEREICH) || archivDaten.equals(AUSGELAGERTER_BEREICH))) {
                    return FARBE_AUSGELAGERTER_BEREICH;
                } else if ((normaleDaten.equals(KEINE_DATEN_FEHLERHAFTE_ANMELDUNG) || archivDaten.equals(KEINE_DATEN_FEHLERHAFTE_ANMELDUNG))) {
                    return FARBE_KEINE_DATEN_FEHLERHAFTE_ANMELDUNG;
                } else if ((normaleDaten.equals(KEINE_DATEN_UNDEFINIERTE_OBJEKTKODIERUNG) || archivDaten.equals(KEINE_DATEN_UNDEFINIERTE_OBJEKTKODIERUNG))) {
                    return FARBE_KEINE_DATEN_UNDEFINIERTE_OBJEKTKODIERUNG;
                }
            }
        }

        return null;
    }

    @Override
    public Color getForeground(Object element) {
        return null;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 08.03.13
