/*
 * @(#)MenuPunktGanglinien.java   28.03.12
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.plugin.gtm.visualisierung.aktionen;

//~ NICHT JDK IMPORTE =========================================================

import de.inovat.buv.gtm.datvew.menu.IMenuPunkt;
import de.inovat.buv.projektlib.rechtevew.aktionen.AktionenVew;
import de.inovat.buv.projektlib.rechtevew.lib.RechteVew;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;

//~ KLASSEN ===================================================================

/**
 * Menpunkt der Navigation "Ganglinien".
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 211 $ / $Date: 2012-10-09 11:50:12 +0200 (Di, 09 Okt 2012) $ / ($Author: LG $)
 */
public class MenuPunktGanglinien implements IMenuPunkt {
    @Override
    public IAction getAktion() {
        return new Action() {
            @Override
            public void run() {
                AktionenVew.getInstanz().ausfuehrenAktionMitDebugausgabe(AktionenVisualisierung.COMMAND_ID_GANGLINIE);
            }
            @Override
            public boolean isEnabled() {
                return RechteVew.getInstanz().istFunktionFuerAngemeldetenBenutzerErlaubt(AktionenVisualisierung.FUNKTION_ID_GANGLINIE);
            }
        };
    }

    @Override
    public String getName() {
        return "Ganglinien";
    }

    @Override
    public String getTyp() {
        return "typ.langZeitZhlstelle";
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 23.10.13
