/*
 * @(#)Zustaende.java   05.03.10
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.projektlib.konstanten;

//~ NICHT JDK IMPORTE =========================================================

import de.bsvrz.buv.rw.basislib.Rahmenwerk;

//~ KLASSEN ===================================================================

/**
 * Klasse definiert Aufrufparameter des Projekts als Konstanten.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 86 $ / $Date: 2013-11-05 13:26:31 +0100 (Di, 05 Nov 2013) $ / ($Author: LG $)
 */
public class AufrufParameter {

    /**
     * Liegt fest, ob der AusgabeOrdner mit den Unterordnern
     * (Projektname_Asugabe\Bundesland) erstellt werden soll.
     */
    public static final String AUSGABE_UNTER_ORDNER = "-inovatUnterOrdnerAnlegen";

    /**
     * Liegt fest, ob das BerechtigungsKonzept eingeschaltet werde soll.
     * Mgliche Werte: true, false.
     */
    public static final String BERECHTIGUNGS_KONZEPT = "-berechtigungsKonzept";

    /** Bundesland, fr das das Projekt gestartet wird. */
    public static final String BUNDESLAND = "-bundesland";

    /** Logo fr das Bundesland, das das Standardlogo ersetzt. */
    public static final String BUNDESLAND_LOGO = "-bundeslandLogo";

    /** DefaultBenutzerOrdner fr die Projekt-AusgabeDateien. */
    public static final String DEFAULT_BENUTZER_ORDNER = "-defaultBenutzerOrdner";

    /**
     * PID des Oberflchenobjekts.
     * Wird ber die Methode {@link Rahmenwerk#getOberflaechenObject()} abgeholt.
     */
    public static final String OBERFLAECHEN_OBJEKT = "-oberflaechenObjekt";

    /** Name des Projekts. */
    public static final String PROJEKT_NAME = "-projektName";

    /** Ordner, wo alle resource-Dateien fr alle Bundeslnder liegen. */
    public static final String RESOURCE_ORDNER = "-resourceOrdner";
}


//~Formatiert mit 'inovat Kodierkonvention' am 05.11.13
