/*
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.projektlib.rechtevew.lib;

//~ NICHT JDK IMPORTE =========================================================

import org.eclipse.core.expressions.PropertyTester;

//~ KLASSEN ===================================================================

/**
 * Tester fr Property, die in extensions angegeben werden knnen.
 * Als Parameter wird die ID der BerechtigungsFunktion erwartet.
 * Tester prft die Rechte des angemeldeten Benutzers auf die Funktion.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 0 $ / $Date: 2008-01-01 00:00:00 +0200 (So, 27 Mai 2007) $ / ($Author: LG $)
 */
public class RechtePropertyTester extends PropertyTester {

    /**
     * Erzeugt eine Instanz der Klasse RechtePropertyTester.
     */
    public RechtePropertyTester() {}

    //~ METHODEN ==============================================================

    @Override
    public boolean test(Object receiver, String property, Object[] args, Object expectedValue) {

        // Parameter: ID der zu prfenden Funktion
        if (property.equals("hatRecht")) {
            try {
                return RechteVew.getInstanz().istFunktionFuerAngemeldetenBenutzerErlaubt(args[0].toString());
            }
            catch (Exception ignored) {}
        }

        return false;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 03.12.13
