/*
 * @(#)ISpeicherVerfuegbarkeit.java   08.10.13
 *
 * Copyright (c) 2008 by inovat, Dipl.-Ing. H. C. Kni
 * ALL RIGHTS RESERVED.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL inovat OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



package de.inovat.buv.projektlib.speicherlistener;

//~ NICHT JDK IMPORTE =========================================================

import de.bsvrz.buv.rw.basislib.einstellungen.EinstellungAvailabilityListener;

import de.inovat.buv.projektlib.rwservice.RWService;

//~ INTERFACES ================================================================

/**
 * Das Interface dient als eine Zwischenschicht zum Rahmenwerk-Service 'Einstellungen' {@link RWService#getEinstellungen()}.
 * </p>
 * Interface wird von Klassen implementiert, die sich als Listener auf die nderungen bezglich der Verfgbarkeit des Speicher
 * bei der {@link SpeicherListenerVew} ber die Methode {@link SpeicherListenerVew#addSpeicherVerfuegbarkeitListener(ISpeicherVerfuegbarkeit)} anmelden.
 * </p>
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 37 $ / $Date: 2013-10-08 13:26:51 +0200 (Di, 08 Okt 2013) $ / ($Author: LG $)
 */
public interface ISpeicherVerfuegbarkeit extends EinstellungAvailabilityListener {}


//~Formatiert mit 'inovat Kodierkonvention' am 08.10.13
