/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;

/**
 * Klasse verwaltet dtd-Element attribut.
 * 
 * <!ELEMENT attribut ( info?, default? ) >
 * <!ATTLIST attribut
 * 		pid NMTOKEN #REQUIRED
 * 		anzahl NMTOKEN #IMPLIED
 * 		anzahlIst (variabel|fest) "fest"
 * 		name NMTOKEN #REQUIRED
 * >
 * 
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class AttributBeschreibung {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Private ----------------------------------------------------------------
	/** bersicht der AttributBeschreibung. */
	private Uebersicht _uebersicht;

	/** Default (kann null sein). */
	private String _default;

	/** Anzahl (kann null sein). */
	private String _anzahl;

	/** AnzahlIst (variabel|fest)*/
	private String _anzahlIst;

	/** Die Definition vom Attribut (kann null sein). */
	private AttributDefinitionBeschreibung _attributDefinitionBeschreibung;

// ------------------------------------------------------------------------
// KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
// ------------------------------------------------------------------------

	/**
	 * Erzeugt eine Instanz der Klasse AttributBeschreibung.
	 *
	 * @param uebersicht
	 * @param default1
	 * @param anzahl
	 * @param anzahlIst
	 * @param attributDefinitionBeschreibung
	 */
	public AttributBeschreibung(Uebersicht uebersicht, String default1,
			String anzahl, String anzahlIst,
			AttributDefinitionBeschreibung attributDefinitionBeschreibung) {
		_uebersicht = uebersicht;
		_default = default1;
		_anzahl = anzahl;
		_anzahlIst = anzahlIst;
		_attributDefinitionBeschreibung = attributDefinitionBeschreibung;
	}

// ------------------------------------------------------------------------
// GETTER / SETTER METHODEN
// ------------------------------------------------------------------------

	/**
	 * Getter fr Eigenschaft 'anzahl'.
	 *
	 * @return Wert der Eigenschaft 'anzahl'.
	 *
	 * @see  {#link _anzahl}
	 */
	public String getAnzahl() {
		return _anzahl;
	}

	/**
	 * Getter fr Eigenschaft 'anzahlIst'.
	 *
	 * @return Wert der Eigenschaft 'anzahlIst'.
	 *
	 * @see  {#link _anzahlIst}
	 */
	public String getAnzahlIst() {
		return _anzahlIst;
	}

	/**
	 * Getter fr Eigenschaft 'attribbutDefinitionBeschreibung'.
	 *
	 * @return Wert der Eigenschaft 'attribbutDefinitionBeschreibung'.
	 *
	 * @see  {#link _attribbutDefinitionBeschreibung}
	 */
	public AttributDefinitionBeschreibung getAttributDefinitionBeschreibung() {
		return _attributDefinitionBeschreibung;
	}

	/**
	 * Getter fr Eigenschaft 'default'.
	 *
	 * @return Wert der Eigenschaft 'default'.
	 *
	 * @see  {#link _default}
	 */
	public String getDefault() {
		return _default;
	}

	/**
	 * Getter fr Eigenschaft 'uebersicht'.
	 *
	 * @return Wert der Eigenschaft 'uebersicht'.
	 *
	 * @see  {#link _uebersicht}
	 */
	public Uebersicht getUebersicht() {
		return _uebersicht;
	}

	/**
	 * Setter fr Eigenschaft 'attribbutDefinitionBeschreibung'.
	 *
	 * @param attribbutDefinitionBeschreibung Wert zum Setzen der Eigenschaft 'attribbutDefinitionBeschreibung'.
	 *
	 * @see {#link _attribbutDefinitionBeschreibung}
	 */
	public void setAttribbutDefinitionBeschreibung(
			AttributDefinitionBeschreibung attribbutDefinitionBeschreibung) {
		_attributDefinitionBeschreibung = attribbutDefinitionBeschreibung;
	}
}
