/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;

import de.inovat.pat.datkat2html.ausgabe.beschreibung.Inhalt.InhaltTyp;

import java.util.ArrayList;

/**
 * Klasse verwaltet dtd-Element info.
 * 
 * <!ELEMENT info ( kurzinfo , beschreibung? ) >
 * 
 * <!ELEMENT kurzinfo ( #PCDATA| %zeichenauszeichnung.klasse; )* >
 * <!ELEMENT beschreibung ( #PCDATA | %absatzauszeichnung.klasse; )* >
 * 
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class InfoBeschreibung {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Private ----------------------------------------------------------------
	/** KurzInfo. */
	private Inhalt _kurzinfo;

	/** Beschreibung (kann null seien). */
	private Inhalt _beschreibung;

// ------------------------------------------------------------------------
// KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
// ------------------------------------------------------------------------

	/**
	 * Erzeugt eine Instanz der Klasse InfoBeschreibung.
	 *
	 * @param kurzInfo
	 * @param beschreibung
	 */
	public InfoBeschreibung(Inhalt kurzInfo, Inhalt beschreibung) {
		if(kurzInfo!=null){
			_kurzinfo = kurzInfo;
		}
		else{
			_kurzinfo=new Inhalt(InhaltTyp.string, new ArrayList<Inhalt>(), "");
		}
		_beschreibung = beschreibung;
	}

// ------------------------------------------------------------------------
// GETTER / SETTER METHODEN
// ------------------------------------------------------------------------

	/**
	 * Getter fr Eigenschaft 'beschreibung'.
	 *
	 * @return Wert der Eigenschaft 'beschreibung'.
	 *
	 * @see  {#link _beschreibung}
	 */
	public Inhalt getBeschreibung() {
		return _beschreibung;
	}

	/**
	 * Getter fr Eigenschaft 'kurzinfo'.
	 *
	 * @return Wert der Eigenschaft 'kurzinfo'.
	 *
	 * @see  {#link _kurzinfo}
	 */
	public Inhalt getKurzinfo() {
		return _kurzinfo;
	}
}
