/*
 * Copyright 2008 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kni, Kln
 * <p>
 * This file is part of de.inovat.pat.datkat2html
 * <p>
 * de.inovat.pat.datkat2html is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * <p>
 * de.inovat.pat.datkat2html is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.pat.datkat2html; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * <p>
 * Contact Information:<br>
 * inovat, Dipl.-Ing. H. C. Kni<br>
 * Klner Strae 30<br>
 * 50859 Kln<br>
 * Phone: +49 2234 4301 800<br>
 * mailto: info@inovat.de
 */
package de.inovat.pat.datkat2html.ausgabe.beschreibung;

import java.util.ArrayList;
import java.util.List;

/**
 * Klasse verwaltet dtd-Element konfigurationsObjekt.
 * 
 * <!ELEMENT konfigurationsObjekt (info?, (datensatz|objektMenge|defaultParameter)*) >
 * <!ATTLIST konfigurationsObjekt
 * 			pid ID #REQUIRED
 * 			id CDATA #IMPLIED
 * 			name CDATA #IMPLIED
 * 			typ NMTOKEN #REQUIRED
 * >
 * 
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 408 $ / $Date: 2010-04-06 08:14:07 +0200 (Di, 06. Apr 2010) $ / ($Author: HCK $)
 */

public class KonfigurationsObjektBeschreibung {
// ------------------------------------------------------------------------
// VARIABLENDEKLARATIONEN
// ------------------------------------------------------------------------

// Private ----------------------------------------------------------------
	/** bersicht der KonfigurationsObjektBeschreibung. */
	private Uebersicht _uebersicht;

	/** ID der KonfigurationsObjektBeschreibung. */
	private String _id;

	/** Typ der KonfigurationsObjektBeschreibung. */
	private TypBeschreibung _typ;

	/** Liste der DatensatzBeschreibungen. */
	private List<DatensatzBeschreibung> _listeDatensatzBeschreibung=new ArrayList<DatensatzBeschreibung>();

	/** Liste der ObjektMengeBeschreibungen. */
	private List<ObjektMengeBeschreibung> _listeObjektMengeBeschreibung=new ArrayList<ObjektMengeBeschreibung>();

	/** Liste der DefaultParameterBeschreibungen. */
	private List<DefaultParameterBeschreibung> _listeDefaultParameterBeschreibung=new ArrayList<DefaultParameterBeschreibung>();

// ------------------------------------------------------------------------
// KONSTRUKTOREN  (und vom Konstruktor verwende Methoden)
// ------------------------------------------------------------------------

	/**
	 * Erzeugt eine Instanz der Klasse KonfigurationsObjektBeschreibung.
	 *
	 * @param uebersicht
	 * @param id
	 * @param typ
	 * @param listeDatensatzBeschreibung
	 * @param listeObjektMengeBeschreibung
	 * @param listeDefaultParameterBeschreibung
	 */
	public KonfigurationsObjektBeschreibung(Uebersicht uebersicht, String id,
			TypBeschreibung typ, List<DatensatzBeschreibung> listeDatensatzBeschreibung,
			List<ObjektMengeBeschreibung> listeObjektMengeBeschreibung,
			List<DefaultParameterBeschreibung> listeDefaultParameterBeschreibung) {
		_uebersicht = uebersicht;
		_id = id;
		_typ = typ;
		if(listeDatensatzBeschreibung!=null){
			_listeDatensatzBeschreibung = listeDatensatzBeschreibung;
		}
		else{
			_listeDatensatzBeschreibung = new ArrayList<DatensatzBeschreibung>();
		}
		if(listeObjektMengeBeschreibung!=null){
			_listeObjektMengeBeschreibung = listeObjektMengeBeschreibung;
		}
		else{
			_listeObjektMengeBeschreibung = new ArrayList<ObjektMengeBeschreibung>();
		}
		if(listeDefaultParameterBeschreibung!=null){
			_listeDefaultParameterBeschreibung = listeDefaultParameterBeschreibung;
		}
		else{
			_listeDefaultParameterBeschreibung = new ArrayList<DefaultParameterBeschreibung>();
		}
	}

// ------------------------------------------------------------------------
// GETTER / SETTER METHODEN
// ------------------------------------------------------------------------

	/**
	 * Getter fr Eigenschaft 'id'.
	 *
	 * @return Wert der Eigenschaft 'id'.
	 *
	 * @see  {#link _id}
	 */
	public String getId() {
		return _id;
	}

	/**
	 * Getter fr Eigenschaft 'listeDatensatzBeschreibung'.
	 *
	 * @return Wert der Eigenschaft 'listeDatensatzBeschreibung'.
	 *
	 * @see  {#link _listeDatensatzBeschreibung}
	 */
	public List<DatensatzBeschreibung> getListeDatensatzBeschreibung() {
		return _listeDatensatzBeschreibung;
	}

	/**
	 * Getter fr Eigenschaft 'listeDefaultParameterBeschreibung'.
	 *
	 * @return Wert der Eigenschaft 'listeDefaultParameterBeschreibung'.
	 *
	 * @see  {#link _listeDefaultParameterBeschreibung}
	 */
	public List<DefaultParameterBeschreibung> getListeDefaultParameterBeschreibung() {
		return _listeDefaultParameterBeschreibung;
	}

	/**
	 * Getter fr Eigenschaft 'listeObjektMengeBeschreibung'.
	 *
	 * @return Wert der Eigenschaft 'listeObjektMengeBeschreibung'.
	 *
	 * @see  {#link _listeObjektMengeBeschreibung}
	 */
	public List<ObjektMengeBeschreibung> getListeObjektMengeBeschreibung() {
		return _listeObjektMengeBeschreibung;
	}

	/**
	 * Getter fr Eigenschaft 'typ'.
	 *
	 * @return Wert der Eigenschaft 'typ'.
	 *
	 * @see  {#link _typ}
	 */
	public TypBeschreibung getTyp() {
		return _typ;
	}

	/**
	 * Getter fr Eigenschaft 'uebersicht'.
	 *
	 * @return Wert der Eigenschaft 'uebersicht'.
	 *
	 * @see  {#link _uebersicht}
	 */
	public Uebersicht getUebersicht() {
		return _uebersicht;
	}
}
